%================================================================
% LaTeX file with preferred layout for H1 paper drafts
% use: dvips -D600 file-name
%================================================================
\documentclass[12pt]{article}
%\usepackage{epsfig}
%\usepackage{amsmath}
%\usepackage{hhline}
%\usepackage{amssymb}
%\usepackage{times}
%\usepackage{cite}
\usepackage{color}

\include{def-jhep-journals}

% create new 'if' command: ifpdf
\newif\ifpdf
 \ifx\pdfoutput\undefined
 \pdffalse                 % we are not running PDFLaTeX
\else
 \pdfoutput=1              % we are running PDFLaTeX
 \pdftrue
\fi


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
\ifpdf  % PDFLatex
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%  include packages necessary for
%  pdflatex ONLY
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
 \pdfadjustspacing=1 %get the same spacing as in Latex
 \pdfcompresslevel=0
 \usepackage{url,xspace,boxedminipage}
 \usepackage{graphicx,thumbpdf}
 \definecolor{rltred}{rgb}{0.75,0,0}
 \definecolor{rltgreen}{rgb}{0,0.5,0}
 \definecolor{rltblue}{rgb}{0,0,0.75}

 \usepackage[pdftex,colorlinks,                          
  ,bookmarks                                             
  ,bookmarksnumbered
%  ,pagebackref
  ,hyperindex
  ,urlcolor=rltblue%
  ,filecolor=rltgreen %rltgreen%
  ,linkcolor=rltgreen %rltred
  ,pdftitle={Physics Analysis Expert PAX: First Applications}%
  ,pdfsubject={PAX}%
  ,pdfkeywords={PAX, C++}%
  ,pdfauthor={Martin Erdmann<erdmann@fnal.gov>}%
  ,pdfpagemode={UseOutlines}%
  ,pdfstartview={Fit}%
  ]{hyperref}
 \pdfimageresolution=300                                
 \DeclareGraphicsExtensions{.pdf,.jpg,.jpeg}  % Grafik-Endungen

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
\else  % Latex
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%  include packages necessary for
%  latex ONLY (PS output file)
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
 \usepackage{graphicx}                        
   \DeclareGraphicsExtensions{.eps,.ps,.eps.gz,.ps.gz} % Grafik-Endungen
  
  \newcommand{\href}[2]{#2} % neccessary to suppress urls in the PS output file
%  \usepackage[dvips,pagebackref]{hyperref} % always use hyperref at last
  \usepackage[dvips,pagebackref]{hyperref} % always use hyperref at last
                                           % needed to get Pagebackref's in the
                                           % Bibliography       
\fi

\definecolor{myorange}{rgb}{0.8,0.2,0.0}
\def\red{\color{myorange}}
\def\blue{\color{blue}}
\def\orange{\color{myorange}}

\DeclareGraphicsRule{*}{mps}{*}{}
\graphicspath{./}


\renewcommand{\topfraction}{1.0}
\renewcommand{\bottomfraction}{1.0}
\renewcommand{\textfraction}{0.0}

\newcommand{\bredb}[1]{{\bf\red #1 }} %makes text in \bf\red
\newcommand{\bblueb}[1]{{\bf\blue #1 }} %makes text in \bf\blue
\newcommand{\blfi}[1]{{\blue #1}} % writes #1 in

\newlength{\dinwidth}
\newlength{\dinmargin}
\setlength{\dinwidth}{21.0cm}
\textheight23.5cm \textwidth17.0cm
\setlength{\dinmargin}{\dinwidth}
\setlength{\unitlength}{1mm}
\addtolength{\dinmargin}{-\textwidth}
\setlength{\dinmargin}{0.5\dinmargin}
\oddsidemargin -1.0in
\addtolength{\oddsidemargin}{\dinmargin}
\setlength{\evensidemargin}{\oddsidemargin}
\setlength{\marginparwidth}{0.9\dinmargin}
\marginparsep 8pt \marginparpush 5pt
\topmargin -42pt
\headheight 12pt
\headsep 30pt \footskip 24pt
\parskip 3mm plus 2mm minus 2mm


%===============================title page=============================
\begin{document}

\pagestyle{empty}

%\include{cdftitlepage}
%\include{cmstitlepage}
\include{kerneltitlepage}

\newpage
~
\newpage
\tableofcontents


\newpage
\pagestyle{plain}
\setcounter{page}{1}

\section{\large Introduction}

\noindent
PAX is a novel, C++ based toolkit designed to assist teams in particle physics data analysis issues. 
The core of PAX are event interpretation containers (class PaxEventInterpret), holding relevant information 
about and possible interpretations of a physics event. Providing this new level of abstraction beyond the 
results of the detector reconstruction programs, PAX facilitates the buildup and use of modern analysis factories. 
Class structure and user command syntax of PAX are set up to support expert teams as well as newcomers in tackling 
challenges arising in data analysis at high energy physics experiments.

\noindent{\bf\large  Physics Objects}

\noindent In {\bf\orange PAX}, the supported physics objects are:
\begin{description}
\item[\orange PaxCollision:]
within a single trigger and the corresponding detector readout,
several collisions may have appeared which the user may want to separate.
\item[\orange PaxVertex:]
the event may have several reconstructed vertices which belong
to the different collisions, or to secondary vertices from 
particle decays.
\item[\orange PaxFourVector:]
particle kinematics can be expressed in terms of fourvectors
which enable calculation of transverse momenta, rapidity,
invariant masses etc.
\end  {description}

\noindent{\bf\large  Event Interpretations and Relation Management}

\noindent
The basic unit in PAX is the 
{\bf\orange ``event interpretation'' PaxEventInterpret} which provides
a general container for High Energy Physics events.
It contains information about collisions, vertices, fourvectors and their relations,
as well as user defined values characterizing the event.
Vertices and fourvectors have the full functionality of the {\bf\orange CLHEP}
(default), or alternatively the {\bf\orange ROOT} library (compiler flag  \mbox{{\bf\blue PAX$\_$ROOT}}).
The event interpretation is also used as the interface to algorithms
such as jet algorithms or procedures to calculate the missing 
transverse momentum.

The object oriented design of PAX allows 
{\bf\orange several event interpretations
to be kept simultaneously} and to add new event interpretations as
the physics analysis of the event progresses.
An example of an analysis structure 
is shown in Fig.~\ref{fig:toproadmap}.
\begin{figure}[hhh]
\setlength{\unitlength}{1cm}
\begin{picture}(15.0,11.0)
\put(0.3,10)
{\large Studied Process }
\put(6.4,10)
{\large Analysis Structure: Advanced Event Interpretations}
\put(0,4){\includegraphics[width=4.5cm]{top-pp-bwt}}
\put(7,0.4){\includegraphics[width=10cm]{toproadmap1}}
\end{picture}
\caption{ Example analysis chain for top production in electroweak processes
where the full boxes represent event interpretations.
\label{fig:toproadmap}
}
\end{figure}
Each event interpretation contains a specific view of the    
event and is highly recommended to carry no ambiguities.
In the case of ambiguities, every possible event interpretation     
should have its own instance.
This recommendation ensures flexibility up to the end of the event analysis.


The relations between collisions, fourvectors, vertices 
are used to provide a {\bf\orange lock mechanism} which enables,
e.g. the consistent exclusion of fourvectors from their use in 
algorithms.
An example is an isolated electron which should not be used 
in the jet finding.
The mechanism is set up in form of a tree structure:
for example, locking a collision will exclude all vertices and fourvectors 
associated with the collision (Fig.~\ref{fig:collisions2}).
Locking a secondary vertex will exclude the fourvectors originating at this
vertex and their decays, but not the collision, not the primary vertex, not 
an incoming fourvector to the secondary vertex.
\begin{figure}[hhh]
\setlength{\unitlength}{1cm}
\begin{picture}(15.0,3.0)
\put(4.5,0.)
{\includegraphics[width=6cm]{collisions2}}
\end{picture}
\caption{ Excluding a collision (left) or a vertex (right) from analysis
using the lock() mechanism excludes all vertices and fourvectors originating
from the excluded object.
\label{fig:collisions2}
}
\end{figure}


PAX is connected to the {\bf\orange detector classes of the experiment} through  
an interface which fills event interpretations
with the best information of the reconstruction program available  
for tracking, muons, calorimeter etc.                                 
A facility to store pointers to the original detector class instances are made available in PAX.

Some remarks on {\bf\orange naming conventions:}
the original PAX functions start with a lower case letter if their name indicates
an action, e.g. getIterator, setPaxName(), etc.
Otherwise functions start with a capital letter, e.g. CurrentItem(), 
IsDone(), etc.
For the convenience of ROOT users, all kernel functions are provided in addition
starting with a capital letter.
If functions have arguments of different classes, the order is 
PaxEventInterpret, PaxCollision, PaxVertex, PaxFourVector, PaxExperimentClass, 
then arguments of another type.
Everywhere the arrow --$>$ can be used.

\clearpage

\newpage
\section{\large Citation and GNU Lesser General Public License}

\noindent{\bf\large  Citation}

\noindent
We kindly ask for the following citation of the Physics Analysis Expert package
when used: 

\noindent
``Physics Analysis Expert (PAX): first applications'',\\
M. Erdmann et al., to appear in the Proceedings of the
International Conference on Computing in High Energy
and Nuclear Physics, CHEP03, La Jolla, USA (2003),
physics/0306085

\noindent
Further references on PAX can be found in \cite{alfa,beta}.

\noindent{\bf\large  License}

\noindent
To increase the functionality of PAX for all users as fast as possible
we encourage you to inform us about your improvements of the PAX library
(mail to project-pax@cern.ch).

Apart from this encouragement, note that 
the PAX library is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation in
version 2.1 of the License.

The PAX library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
Lesser General Public License for more details.

You should have received a copy of the GNU Lesser General Public
License along with this library in the file called LICENSE; 
if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, 
Boston, MA  02111-1307  USA.

%\include{cdfinstallation}
%\include{cmsinstallation}
\include{kernelinstallation}

\section{\large The class PaxEventInterpret: multiple event interpretations }

\noindent
The class PaxEventInterpret provides the ``basic unit'' in PAX.
It stores information about collisions, vertices, fourvectors and their relations.
It also remembers user defined values or algorithm dependent values 
characterizing the event.
The event interpretation is also used as the interface to algorithms
such as jet algorithms, or procedures to calculate the missing 
transverse momentum.

\begin{figure}[hhh]
\setlength{\unitlength}{1cm}
\begin{picture}(15.0,9.5)
\put(2,0.4)
{\includegraphics[width=13cm]{eventinterpret5}}
\end{picture}
\caption{ The basic unit in PAX: the event interpretation
together with the classes for collisions, vertices, fourvectorsand 
user records.
\label{fig:eventinterpret1}
}
\end{figure}

PAX allows several event interpretations to be kept simultaneously 
and to add new event interpretations as the physics analysis of the event 
advances.
Usually one starts with an event interpretation offered by the
event reconstruction program of the experiment, e.g. tracks and
vertices, calorimeter towers or clusters, jets, electrons, muons etc.
Every interpretation can be copied into its own instance of PaxEventInterpret
via example interface as described in section~\ref{sec:examples}.

Then the user wants to advance the interpretation of the event 
according to his/her physics questions.
Every progress can be stored in a new instance of PaxEventInterpret
such that a full record of the analysis procedure remains available
to the user.
An example of an analysis structure 
is shown in Fig.~\ref{fig:toproadmap}.
We recommend that an instance of PaxEventInterpret does not carry ambigues
information. 
In the case of ambiguities, every possible event interpretation     
should have its own instance.
This recommendation ensures flexibility in decisions
up to the end of the event analysis.

\noindent
PaxEventInterpretations are booked on the heap.
The available constructor calls are \\
{\bf\red PaxEventInterpret* event$\_$interpret = new PaxEventInterpret;} \\
as well as the copy constructor using a previous event interpretation \\
{\bf\red PaxEventInterpret* event$\_$interpret$\_$copy = new PaxEventInterpret(event$\_$interpret);} \\
This copy will be a physical copy of the event interpretation on the heap
which sets relations, e.g. between vertices and fourvectors within the
copied event interpretion.
It also keeps relations, e.g. between the original and the copied
fourvector instances. \\
\\
Delete the event interpret instances at the end of the event analysis, with\\
{\bf\red delete event$\_$interpret;} \\
{\bf\red delete event$\_$interpret$\_$copy;} \\
This will automatically delete all collisions, vertices, fourvectors, 
user records and experiment class pointers registered with the event 
interpretation.

\subsection{\large PaxEventInterpret member functions \label{ssec:PaxEventInterpretMemberFunctions}}

PaxEventInterpret stores collisions, vertices, fourvectors and user records.
In Tables~\ref{Member functions of PaxEventInterpret 1} and
\ref{Member functions of PaxEventInterpret 2}, 
member functions for the class PaxEventInterpret are shown.

\begin{table}[hhh]
\begin{center}
\caption{Member functions of class PaxEventInterpret}
\label{Member functions of PaxEventInterpret 1}
\footnotesize{ %!
   \begin{tabular}{|ll|l|}
	\hline
\multicolumn{1}{|c|}{type}&\multicolumn{1}{c|}{name}&\multicolumn{1}{c|}{description }\\ 
   \hline \hline
   {\bf\orange  void } & {\bf\orange add( PaxCollision*  c )         } & register pointer to PaxCollision  instance \\ \hline
   {\bf\orange  void } & {\bf\orange add( PaxVertex*     v )         } & register pointer to PaxVertex     instance\\ \hline
   {\bf\orange  void } & {\bf\orange add( PaxFourVector* f )         } & register pointer to PaxFourVector instance\\ \hline
   {\bf\orange  void } & {\bf\orange add( string s, double value )} & add (string,double) pair to user records\\ \hline
   {\bf\orange  void } & {\bf\orange addRelations( } & add relations to collisions, \\ \hline
   & {\bf\orange ~~~~PaxEventInterpret* ei) } & vertices, fourvectors of ei which have the \\ 
   & & same origin in experiment classes\\ \hline
   {\bf\orange  void } & {\bf\orange clear()                  } & delete all registered instances, clear 
   containers \\ \hline
   {\bf\orange  PaxCollision* } & {\bf\orange create$<$PaxCollision$>$() } & create and register new collision \\ \hline
   {\bf\orange  PaxCollision* } & {\bf\orange create$<$PaxCollision$>$ } & create and register new collision \\ 
   &  {\bf\orange ~~~~(PaxCollision* c) } & as a copy of collision c\\  \hline
   {\bf\orange  PaxFourVector* } & {\bf\orange create$<$PaxFourVector$>$() } & create and register new fourvector \\ \hline
   {\bf\orange  PaxFourVector* } & {\bf\orange create$<$PaxFourVector$>$ } & create and register new fourvector \\ 
   &  {\bf\orange ~~~~(PaxFourVector* f) } & as a copy of fourvector f\\ \hline
   {\bf\orange  PaxFourVector* } & {\bf\orange create$<$PaxFourVector, } & create and register new fourvector \\
   &  {\bf\orange ~~~~PaxVertex$>$(PaxVertex* v) } & from outgoing fourvectors of vertex v\\ \hline
   {\bf\orange  PaxVertex* } & {\bf\orange create$<$PaxVertex$>$() } & create and register new vertex \\ \hline
   {\bf\orange  PaxVertex* } & {\bf\orange create$<$PaxVertex$>$} & create and register new vertex \\ 
   & {\bf\orange ~~~~(PaxVertex* v) }  & as a copy of vertex v\\ \hline
   {\bf\orange  PaxVertex* } & {\bf\orange create$<$PaxVertex,} & create and register new vertex \\ 
   &  {\bf\orange ~~~~Hep3Vector$>$(Hep3Vector* h) }& using values of vector h \\ \hline
   {\bf\orange  void } & {\bf\orange copy( PaxEventInterpret* ei) }    & deep copy \\ \hline
   {\bf\orange  void } & {\bf\orange deleteCopyInformation() }    & delete the last copy history \\ \hline
   {\bf\orange   int  }&{\bf\orange  findCopyOf(int id)   } & find PAX id of copied physics object \\ 
   & &  in the copy of an event interpretation \\ \hline
   {\bf\orange   PaxCollision*  }&{\bf\orange  findCopyOf(PaxCollision* c)   } & find collision c in the copy \\
   & & of an event interpretation \\ \hline
   {\bf\orange   PaxFourVector*  }&{\bf\orange  findCopyOf(PaxFourVector* f)   } & find fourvector f in the copy \\
   & & of an event interpretation \\ \hline
   {\bf\orange   PaxVertex*  }&{\bf\orange  findCopyOf(PaxVertex* v)   } & find vertex v in the copy \\
   & & of an event interpretation \\ \hline
   {\bf\orange   PaxCollision*  }&{\bf\orange  findCollision(int id)  } & find collision c  using unique pax identifier \\ \hline
   {\bf\orange   PaxFourVector* }&{\bf\orange  findFourVector(int id) } & find fourvector f using unique pax identifier  \\ \hline
   {\bf\orange   PaxVertex*     }&{\bf\orange  findVertex(int id)     } & find vertex v     using unique pax identifier \\ \hline
   {\bf\orange   PaxCollision*  }&{\bf\orange  findCollision(string key)  } & find collision c  registered \\
   & & in user record as ``id$\_$name'' \\ \hline
   {\bf\orange   PaxFourVector* }&{\bf\orange  findFourVector(string key) } & find fourvector f registered \\
   & & in user record as ``id$\_$name'' \\ \hline
   {\bf\orange   PaxVertex*     }&{\bf\orange  findVertex(string key)     } & find vertex v     registered \\
   & & in user record as ``id$\_$name'' \\ \hline
   {\bf\orange  bool } & {\bf\orange checkUserRecord( string key,} & check if user record exists and \\
   & {\bf\orange ~~~~double* var=0, double default=NAN )}&store its value in var (optional)\\ \hline
   {\bf\orange  double } & {\bf\orange findUserRecord( string key,} & find value in user record\\ 	
&{\bf\orange ~~~~double default=NAN )}&\\ \hline	
   \end{tabular}
}
\end{center}
\end{table}   
\begin{table}[hhh]
\begin{center}
\caption{Member functions of class PaxEventInterpret}
\label{Member functions of PaxEventInterpret 2}
\footnotesize{ %!
 \begin{tabular}{|ll|l|}
	\hline
	\multicolumn{1}{|c|}{type}&\multicolumn{1}{c|}{name}&\multicolumn{1}{c|}{description }\\ 
	   \hline \hline
   {\bf\orange   PaxCollisionMap*  }&{\bf\orange  getCollisions()   } & get collision container \\ 	\hline
   {\bf\orange   PaxFourVectorMap* }&{\bf\orange  getFourVectors() } & get fourvector container \\ 	\hline
   {\bf\orange  int  } & {\bf\orange getPaxId()                     } & get PAX id of this instance\\	\hline
   {\bf\orange   string } & {\bf\orange    getPaxName()           } &get event interpret name \\ 	\hline
   {\bf\orange   PaxUserRecord*    }&{\bf\orange  getUserRecords() } & get container of user records\\ 	\hline
   {\bf\orange   PaxVertexMap*     }&{\bf\orange  getVertices()    } & get vertex container \\ 	\hline
   {\bf\orange   int   } & {\bf\orange    getWorkflag()   } & get temporary work flag \\ 	\hline
   {\bf\orange  bool } & {\bf\orange IsEmpty()                    } & true if containers are empty\\ 	\hline
   {\bf\orange  bool } & {\bf\orange isolate( int i = 1 )         } & remove relations to objects outside of this event\\ 
   & & interpretation. i$<$0 keeps \\
   & & experiment class relations\\ 	\hline
   & {\bf\orange PaxEventInterpret } & constructor for empty event interpretation\\ 	\hline
   & {\bf\orange PaxEventInterpret(} & constructor copying event\\ 	\hline
   & {\bf\orange PaxEventInterpret* ei) } &  interpretation ei\\ 	\hline
   & {\bf\orange $\sim$PaxEventInterpret() } & destructor
   deletes all registered instances\\ 	\hline
   {\bf\orange  void } & {\bf\orange print( int level ) }   & print collisions, vertices, fourvectors, their\\
   & & relations and user records: print level (see~\ref{printlevel}) \\	\hline
   {\bf\orange  void } & {\bf\orange removeUserRecord(  } & remove (string,double) pair from\\
   & {\bf\orange  string s ) } & user record\\	\hline
   {\bf\orange   void   } & {\bf\orange    setPaxName(string s)   } & set event interpret name \\	\hline
   {\bf\orange   void   } & {\bf\orange    setWorkflag(int i)   } & set temporary work flag \\ 	\hline
   {\bf\orange  void } & {\bf\orange setUserRecord( } & set (string,double) pair in \\ 	\hline
   & {\bf\orange  ~~~~string s, double d )} & user record\\ 	\hline
   %{\bf\orange  void } & {\bf\orange remove( PaxCollision*  c )         } & unregister pointer to PaxCollision  instance \\
   %{\bf\orange  void } & {\bf\orange remove( PaxVertex*     v )         } & unregister pointer to PaxVertex     instance\\
   %{\bf\orange  void } & {\bf\orange remove( PaxFourVector* f )         } & unregister pointer to PaxFourVector instance\\
   \end{tabular}
}   
\end{center}
\end{table}   


\subsection{\large Fill collisions, vertices, fourvectors }

\noindent
An example how to create a collision, a vertex and a fourvector 
within an event interpretation is given here:\\
\\
// make event interpretation\\
{\bf\red   PaxEventInterpret* event$\_$interpret = new PaxEventInterpret;}\\
\\
// make collision and add collision to event interpretation\\
{\bf\red   PaxCollision* c = event$\_$interpret--$>$create$<$PaxCollision$>$(); } \\
\\
// make vertex and add vertex to event interpretation\\
{\bf\red   PaxVertex* v = event$\_$interpret--$>$create$<$PaxVertex$>$(); } \\
\\
// make fourvector and add fourvector to event interpretation\\
{\bf\red   PaxFourVector* f = event$\_$interpret--$>$create$<$PaxFourVector$>$(); } \\
\\
For filling a user record see below 
section~\ref{sec:eventinterpret user records}.

%For removing a PaxCollision, PaxVertex, or PaxFourVector instance from the
%PaxEventInterpret instance replace the above {\bf\red Add} by {\bf\red Remove}

\subsection{\large Access collisions, vertices, fourvectors }

\noindent
Examples how to access collisions, vertices and fourvectors
of the event interpretation are given here:\\
\\
// print collisions, vertices, fourvectors, 
their relations and user records \\
{\bf\red  event$\_$interpret--$>$print(); }\\
\\
// check number of collisions registered in the instance event$\_$interpret of PaxEventInterpret \\
{\bf\red  event$\_$interpret--$>$getCollisions()--$>$getSize(); }\\
\\
// get iterator for collisions from instance event$\_$interpret of PaxEventInterpret \\
{\bf\red  PaxIterator$<${\blue PaxCollision}* $>$* iter = 
event$\_$interpret--$>${\blue getCollisions()}--$>$getIterator();}\\
{\bf\red  for ( iter--$>$First(); !iter--$>$IsDone(); iter--$>$Next() )\{}\\
{\bf\red  ~~~iter--$>$CurrentItem()--$>$print();}\\
{\bf\red \}}
\\
// get iterator for vertices from instance event$\_$interpret of PaxEventInterpret \\
{\bf\red  PaxIterator$<${\blue PaxVertex}* $>$* iter = 
event$\_$interpret--$>${\blue getVertices()}--$>$getIterator();}\\
{\bf\red  for ( iter--$>$First(); !iter--$>$IsDone(); iter--$>$Next() )\{}\\
{\bf\red  ~~~iter--$>$CurrentItem()--$>$print();}\\
{\bf\red  \}}\\
\\
// get iterator for fourvectors from instance event$\_$interpret of PaxEventInterpret \\
{\bf\red  PaxIterator$<${\blue PaxFourVector}* $>$* iter = 
event$\_$interpret--$>${\blue getFourVectors()}--$>$getIterator();}\\
{\bf\red  for ( iter--$>$First(); !iter--$>$IsDone(); iter--$>$Next() ) \{}\\
{\bf\red  ~~~iter--$>$CurrentItem()--$>$print();}\\
{\bf\red \}}
\\
For accessing a user record see below 
section~\ref{sec:eventinterpret user records}.


\subsection{\large Relations to true information of a generated event
\label{sec:eventinterpret addrelations}}

\noindent
For some application one wants to relate the fourvectors of different
event interpretations based on the common original detector information.
An example is the relation between a reconstructed jet fourvector of
the current event interpretation (event$\_$interpret$\_$jet) which one may want to relate to the
fourvectors of an event interpretation filled with the original monte 
carlo fourvectors (event$\_$interpret$\_$monte$\_$carlo).
Such relations between fourvectors which come from the same original 
instance of an experiment class can be added using\\
{\bf\red event$\_$interpret$\_$jet--$>$addRelations( event$\_$interpret$\_$monte$\_$carlo ) }. \\
Also relations to collisions and vertices
which have the same origin in the experiment classes will be added.

\subsection{\large User records \label{sec:eventinterpret user records}}

\noindent
The user can store additional information in the PaxEventInterpretation instance 
event$\_$interpret using the PaxUserRecord facility.
It consists of a map  with key {\em string} and 
mapped type {\em double} which can be searched correspondingly.
The command syntax to fill the information under the name ``myexpression'' is\\
{\bf\red 
event$\_$interpret--$>$setUserRecord( "myexpression", 0.456 );}\\
\\
Retrieving the information works through a search.
It returns either the corresponding value for the key or throws an exception in case no user record was found \\
{\bf\red 
double value = event$\_$interpret--$>$findUserRecord( "myexpression" );} \\
It is possible to provide a default value which is then returned instead of the exception, in case no user record was found:\\
{\bf\red 
double default = 999.;}\\
{\bf\red double value = event$\_$interpret--$>$findUserRecord( "myexpression" , default);} \\
Another possibilty is to check, whether a user record exists:\\
{\bf\red bool IsUR = event$\_$interpret--$>$checkUserRecord( "myexpression");} \\
\\
For removing a user record use \\
{\bf\red event$\_$interpret--$>$removeUserRecord( ''myexpression'' );}\\
\\
Direct access to the user records container is given by \\
{\bf\red PaxUserRecord* ur = event$\_$interpret--$>$getUserRecords();}


\noindent
If you want to store unique PAX identifiers in the user records
of an event interpretation, their name should begin with 
``{\bf\blue id$\_$}''. 
When copying an event interpretation, 
new instances are created with new unique PAX identifiers.
User records with name ``{\bf\blue id$\_$}'' are updated automatically 
to carry the new PAX identifier in the copied instance of the event 
interpretation.
The user records are also correctly updated when writing the event 
interpretation to a disk file and reading it back.


\newpage
\section{\large The class PaxCollision}

\noindent
The class PaxCollision holds collisions found in the event
(Fig.~\ref{fig:collisions2}).
It stores the related vertices and the related fourvectors.
Furthermore, the user can store analysis dependent results 
in a map with key {\em string} and mapped type {\em double} which 
can be searched correspondingly.
This map is also used by algorithms to store additional information.

\noindent
PaxCollisions are always booked on the heap.
If you intend to create them within an event interpretation event$\_$interpret 
we recommend to use \\
{\bf\red   PaxCollision* c = event$\_$interpret--$>$create$<$PaxCollision$>$(); } \\
or the copy constructor \\
{\bf\red   PaxCollision* c1 = event$\_$interpret--$>$create$<$PaxCollision$>$(c); } \\
\\
The ``create'' function provides a shortcut using the available constructor calls \\
{\bf\red       PaxCollision* c = new PaxCollision;}\\
or the copy constructor \\
{\bf\red       PaxCollision* c1 = new PaxCollision(c);}\\
together with the add() function which is used to register the collision
in the event interpretation.
Note that every PaxCollision which has been registered in an instance of PaxEventInterpret,
e.g. event$\_$interpret, by 
\mbox{PaxCollision* c = event$\_$interpret--$>$create$<$PaxCollision$>$()} or 
\mbox{event$\_$interpret--$>$add(c)}
is automatically deleted when calling \\
{\bf\red delete event$\_$interpret;}\\
Since a PaxCollision instance does not know its PaxEventInterpret instance
do not delete a PaxCollision instance registered by 
event$\_$interpret--$>$add(c), or --$>$create$<$PaxCollision$>$() yourself.

\subsection{\large PaxCollision members and relations}

\noindent
In Table~\ref{Member functions of PaxCollision}, member functions 
for the class PaxCollision are shown.
Fig.~\ref{fig:relation1} displays the relations available to 
collisions, vertices and fourvectors.

\begin{figure}[hhh]
\setlength{\unitlength}{1cm}
\begin{picture}(15.0,11.5)
\put(1,0.4)
{\includegraphics[width=15cm]{relation5}}
\end{picture}
\caption{ The relations in PAX
\label{fig:relation1}
}
\end{figure}


\begin{table}[hhh]
\begin{center}
\caption{Member functions of class PaxCollision}
\label{Member functions of PaxCollision}
\footnotesize{ %!	
 \begin{tabular}{|ll|l|}
	\hline
	\multicolumn{1}{|c|}{type}&\multicolumn{1}{c|}{name}&\multicolumn{1}{c|}{description }\\ 
   \hline \hline
   {\bf\orange  void } & {\bf\orange add(string s, double value)} & add (string,double) pair \\
   & & to user records\\  \hline
   {\bf\orange  void } & {\bf\orange addExperimentClassRelations} & add experiment class instances \\
                       & {\bf\orange ~~~~~(PaxCollision* c)} & of another collision c\\  \hline
   {\bf\orange  void } & {\bf\orange addPointer$<$ABC$>$} & register pointer q of \\
                       & {\bf\orange ~~~~~(``class ABC'', 0, q)} & an arbitrary class ABC\\  \hline
   {\bf\orange  bool } & {\bf\orange checkUserRecord( string key,} & check if user record exists and \\
   & {\bf\orange ~~~~double* var=0, double default=NAN )}&store its value in var (optional)\\ \hline
   {\bf\orange   bool } & {\bf\orange CommonExperimentClassRelations} & true if common experiment \\
                        & {\bf\orange ~~~~~(PaxCollision* c)    } & class instances exist \\  \hline
   {\bf\orange   void } & {\bf\orange copy(PaxCollision* c)            } &deep copy\\  \hline
   {\bf\orange  ABC* } & {\bf\orange findPointer$<$ABC$>$} & return registered pointer\\
                       & {\bf\orange ~~~~~(``class ABC'', 0)}& of the arbitrary class ABC\\  \hline
   {\bf\orange  double } & {\bf\orange findUserRecord(string s, double default=NAN)} & find value in user record\\  \hline
   {\bf\orange   PaxCollisionRelations* } & {\bf\orange getCollisionRelations() } & get container of collision rel. \\  \hline
   {\bf\orange   PaxFourVectorRelations*} & {\bf\orange getFourVectorRelations()} & get container of fourvectors rel. \\   \hline
   {\bf\orange   int } & {\bf\orange       getPaxId()            } &get PAX id of this instance\\  \hline
   {\bf\orange   string } & {\bf\orange    getPaxName()           } &get collision name \\  \hline
   {\bf\orange   int    } & {\bf\orange    getStatus()         } &get status word\\  \hline
   {\bf\orange   PaxUserRecord*         } & {\bf\orange getUserRecords() }& get container of user records\\  \hline
   {\bf\orange   PaxVertexRelations*    } & {\bf\orange getVertexRelations()    } & get container of vertices rel.\\   \hline
   {\bf\orange   int   } & {\bf\orange    getWorkflag()   } & get temporary work flag \\  \hline
   {\bf\orange   bool} & {\bf\orange IsLocked()             } &returns true if collision is locked\\  \hline
   {\bf\orange   void} & {\bf\orange lock()                 } &lock collision, related vertices, \\
   & & and related fourvectors \\  \hline
   & {\bf\orange PaxCollision        } &constructor\\  \hline
   & {\bf\orange PaxCollision(PaxCollision* c)     } &constructor copying collision c \\  \hline
   & {\bf\orange $\sim$PaxCollision()     } &destructor\\  \hline
   {\bf\orange   void} & {\bf\orange print(int level)           } &print collision attributes: \\ 
   & & print level (see~\ref{printlevel})\\  \hline
   {\bf\orange   void}&{\bf\orange printDecayTree(int level)   }& print decay tree of PaxCollision: \\
   & & print level (see~\ref{printlevel})\\  \hline
   {\bf\orange  void } & {\bf\orange removeUserRecord(string s)} & remove (string,double) pair \\
   & & from user records\\  \hline
   {\bf\orange   void   } & {\bf\orange    setPaxName(string s)   } &set collision name \\  \hline
   {\bf\orange   void   } & {\bf\orange    setStatus(int s)    } &set status word \\  \hline
   {\bf\orange  void } & {\bf\orange setUserRecord(string s, double d)} & set (string,double) pair \\
   & & in user records\\  \hline
   {\bf\orange   void} & {\bf\orange unlock()               } &unlock collision, related vertices, \\
   & & and related fourvectors\\  \hline
   {\bf\orange   void   } & {\bf\orange    setWorkflag(int i)   } & set temporary work flag \\
   \hline
   \end{tabular}
}   
\end{center}
\end{table}   


%%%%%%%%
\subsection{\large Operators for the class PaxCollision}
An object of the class PaxCollision has no spatial components.
A PaxCollision is an object, helpful for bookkeeping purposes.
Thus, there is neither an increment nor a decrement operator, only a streaming operator (see Table~\ref{operators for class PaxCollision}).

\begin{table}[hhh]
\begin{center}
\caption{Operators for class PaxCollision}
\label{operators for class PaxCollision}
\footnotesize{ %!
 \begin{tabular}{|ll|l|}
	\hline
\multicolumn{1}{|c|}{type}&\multicolumn{1}{c|}{operator}&\multicolumn{1}{c|}{description }\\ 
   \hline \hline
   {\bf\orange   ostream\&}&{\bf\orange operator$<<$(ostream\& os, const PaxCollision\& c)} & streaming operator\\  \hline
   \end{tabular}
}
\end{center}
\end{table}   




\subsection{\large Fill PaxCollision and its relations}

\noindent
// make collision and add collision to event interpretation\\
{\bf\red   PaxCollision* c = event$\_$interpret--$>$create$<$PaxCollision$>$(); } \\
\\
Filling of the PaxCollision c is done by setFunctions \\
{\bf\red
      string s = "minimum bias"; \\
      c--$>$setPaxName(s);\\
}
\\
A relation to another PaxCollision q (Fig.~\ref{fig:relation1}) is stored by \\
{\bf\red c--$>$getCollisionRelations()--$>$add(c,q);}\\
\\
A relation to a PaxVertex v is stored by \\
{\bf\red c--$>$getVertexRelations()--$>$add(c,v);}\\
\\
The relation to a PaxFourVector f belonging to this collision is stored by \\
{\bf\red c--$>$getFourVectorRelations()--$>$add(c,f);}\\
\\
Register the pointer to the instance of an arbitrary detector class DetCollision with the PaxCollision c 
in slot 3 \\
{\bf\red   DetCollision* p = ...; } \\
{\bf\red   c--$>$addPointer$<$DetCollision$>$(``class DetCollision'', 3, p); } \\
\\
For filling a user record see below 
section~\ref{sec:collision user records}.

\subsection{\large Access to PaxCollision and its relations}

\noindent
To access information of the PaxCollision instance c use the member functions
described in Table~\ref{Member functions of PaxCollision}.
Examples are the name of the collision\\
{\bf\red c--$>$getPaxName();}\\
\\
// or print all information on the collision c \\
{\bf\red c--$>$print() }\\
\\
To print only the PaxCollision instances related 
to c get the iterator for the PaxCollisionRelations (Fig.~\ref{fig:relation1})\\
{\bf\red PaxIterator$<${\blue PaxCollision}* $>$* 
iter = c--$>${\blue getCollisionRelations()}--$>$getIterator();\\
for ( iter--$>$First(); 
!iter--$>$IsDone(); 
iter--$>$Next() )\{\\}
{\bf\red~~~iter--$>$CurrentItem()--$>$print(); 
\}\\
}
\\
To print only the PaxVertex instances related 
to c get the iterator for the PaxVertexRelations \\
{\bf\red PaxIterator$<${\blue PaxVertex}* $>$* 
iter = c--$>${\blue getVertexRelations()}--$>$getIterator();\\
for ( iter--$>$First(); 
!iter--$>$IsDone(); 
iter--$>$Next() )\{ \\}
{\bf\red~~~iter--$>$CurrentItem()--$>$print(); \\
\}\\
}
\\
To access the transverse momentum of related fourvectors
via the PaxFourVectorRelations use\\
{\bf\red 
PaxIterator$<${\blue PaxFourVector}* $>$* 
iter = c--$>${\blue getFourVectorRelations()}--$>$getIterator();\\
for ( iter--$>$First(); 
!iter--$>$IsDone(); 
iter--$>$Next() ) \{ \\}
{\bf\red~~~iter--$>$CurrentItem()--$>$perp(); \\
\}\\
}
\\
To access the original detector class instances of PaxCollision c \\
// check whether a pointer to an instance of the arbitrary class DetCollision \\
// has been registered in slot 3 \\
{\bf\red   DetCollision* p = c--$>$findPointer$<$DetCollision$>$(``class DetCollision'', 3 ); } \\
// access member function printChi2() of class DetCollision \\
{\bf\red   if ( p ) p--$>$printChi2(); }\\
\\
For access to the user records see below 
section~\ref{sec:collision user records}.



\subsection{\large Exclude, re-include PaxCollision}

\noindent
The lock mechanism is used to exclude a complete collision from the analysis
together with the vertices and fourvectors assigned to it.
An example is shown on the left side of Fig.~\ref{fig:collisions2}.
The lock command of a PaxCollision c\\
{\bf\red c--$>$lock();}\\
sets the lock flag for c,
for all related PaxVertex instances registered in PaxVertexRelations of c, and
for all related PaxFourVector instances registered in PaxFourVectorRelations of c.
They will lock their related objects as described in 
sections~\ref{lock vertex} and \ref{lock fourvector}.
In this way, all related vertices and all dependent PaxFourVector instances are
automatically excluded in all
event interpretations which exist at the time the command is issued.
A typical command syntax to check for unlocked PaxCollision instances q is\\
{\bf\red if ( !q--$>$IsLocked() ) ...}\\
\\
Unlocking the PaxCollision c is done by\\
{\bf\red c--$>$unlock();}\\
It unsets the lock flag for c and all PaxFourVector and PaxVertex instances
related to c in PaxVertexRelations and in 
PaxFourVectorRelations at the time the command is issued.



\subsection{\large User records \label{sec:collision user records}}

\noindent
The user can store additional information on the PaxCollision c using the
PaxUserRecord facility.
It consists of a map  with key {\em string} and 
mapped type {\em double} which can be searched correspondingly.
The command syntax to fill the information under the name ``myexpression'' is\\
{\bf\red 
c--$>$setUserRecord( "myexpression", 0.456 );}\\
\\
Retrieving the information works through a search.
It returns either the corresponding value for the key or throws an exception in case no user record was found \\
{\bf\red 
double value = c--$>$findUserRecord( "myexpression" );} \\
It is possible to provide a default value which is then returned instead of the exception, in case no user record was found:\\
{\bf\red 
double default = 999.;}\\
{\bf\red double value = c--$>$findUserRecord( "myexpression" , default);} \\
Another possibilty is to check, whether a user record exists:\\
{\bf\red bool IsUR = c--$>$checkUserRecord( "myexpression");} \\
\\
For removing a user record use \\
{\bf\red c--$>$removeUserRecord( "myexpression" );}\\
\\
Direct access to the user records container is given by \\
{\bf\red PaxUserRecord* ur = c--$>$getUserRecords();}


\newpage
\section{\large The class PaxVertex}

\noindent
The class PaxVertex holds the vertices found in the event.
The base class of PaxVertex can be chosen to be the {\bf\blue ROOT} library 
class {\bf\blue TVector3} which makes the entire functionality of this
ROOT class available to the user (compiler flag  \mbox{{\bf\blue PAX$\_$ROOT}}).
Without this flag, the {\bf\blue Hep3Vector} of the {\bf\blue CLHEP} library is used

In addition to the ROOT, or CLHEP functionality, PaxVertex offers storage 
for different information needed during analysis.
Examples are related vertices, outgoing fourvectors originating
at the vertex, possibly an incoming fourvector, the collision, 
and related instances of the original classes of the experiment.
Furthermore, the user can store analysis dependent results 
in a map with key {\em string} and mapped type {\em double} which 
can be searched correspondingly.
This map is also used by algorithms to store additional information.

\noindent
A PaxVertex is always booked on the heap.
If you intend to create them within an event interpretation event$\_$interpret 
we recommend to use \\
{\bf\red   PaxVertex* v = event$\_$interpret--$>$create$<$PaxVertex$>$(); } \\
or the copy constructor \\
{\bf\red   PaxVertex* v1 = event$\_$interpret--$>$create$<$PaxVertex$>$(v); } \\
\\
The ``create'' function provides a shortcut using the available constructor calls \\
{\bf\red       PaxVertex* v = new PaxVertex;}\\
or the copy constructor \\
{\bf\red       PaxVertex* v1 = new PaxVertex(v);}\\
together with the add() function which is used to register the vertex
in the event interpretation.
Note that every PaxVertex which has been registered in an instance of PaxEventInterpret,
e.g. event$\_$interpret, by 
\mbox{PaxVertex* v = event$\_$interpret--$>$create$<$PaxVertex$>$()} or 
\mbox{event$\_$interpret--$>$add(v)}
is automatically deleted when calling \\
{\bf\red delete event$\_$interpret;}\\
Since a PaxVertex instance does not know its PaxEventInterpret instance
do not delete a PaxVertex instance registered by 
event$\_$interpret--$>$add(v), or event$\_$interpret--$>$create$<$PaxVertex$>$() yourself.



\subsection{\large PaxVertex members and relations}

\noindent
In Tables~\ref{Member functions of PaxVertex 1} and
\ref{Member functions of PaxVertex 2}, member functions 
for the class PaxVertex are shown.
With the compiler flag  \mbox{{\bf\blue PAX$\_$ROOT}} set
the full functionality of the ROOT class TVector3 is
available where the most important functions are mentioned
at the top of the table.
Otherwise the full functionality of the CLHEP class Hep3Vector is
available where the most important functions are mentioned
in the same table.
Refer to their user guides for more information.
All member functions offered by PAX in addition are shown in the table.
Fig.~\ref{fig:relation1} displays the relations of
collisions, vertices and fourvectors.

\begin{table}[hhh]
\begin{center}
\caption{Member functions of class PaxVertex}
\label{Member functions of PaxVertex 1}
\footnotesize{ %!
   \begin{tabular}{|ll|l|}
	\hline
\multicolumn{1}{|c|}{type}&\multicolumn{1}{c|}{name}&\multicolumn{1}{c|}{description }\\ 
   \hline \hline
   {\bf\orange double}&{\bf\orange x(), X()  } & get x-coordinate of vertex \\  
   {\bf\orange double}&{\bf\orange y(), Y()  } & get y-coordinate of vertex \\  
   {\bf\orange double}&{\bf\orange z(), Z()  } & get z-coordinate of vertex \\  
   \hline
   {\bf\orange void}&{\bf\orange setX(double x), SetX(double x)} & set x-coordinate of vertex \\
   {\bf\orange void}&{\bf\orange setY(double y), SetY(double y)} & set y-coordinate of vertex \\
   {\bf\orange void}&{\bf\orange setZ(double z), SetZ(double z)} & set z-coordinate of vertex \\ \hline
   & default: & \\
   & {\bf\blue CLHEP library} & all functionality of Hep3Vector \\
   & compiler flag  {\bf\blue PAX$\_$ROOT} set: & \\
   & {\bf\blue ROOT library} & all functionality of TVector3 \\
   \hline
   {\bf\orange  void } & {\bf\orange add(string s, double value)} & add (string,double) pair \\
   & & to user records\\ \hline
   {\bf\orange  void } & {\bf\orange  addExperimentClassRelations} & add experiment class \\
   & {\bf\orange ~~~~~(PaxVertex* v)} & instances of vertex v \\ \hline
   {\bf\orange  void } & {\bf\orange addPointer$<$ABC$>$} & register pointer q of \\
   & {\bf\orange ~~~~~(``class ABC'', 0, q)} & an arbitrary class ABC\\   \hline
   {\bf\orange  bool } & {\bf\orange checkUserRecord( string key,} & check if user record exists and \\
   & {\bf\orange ~~~~double* var=0, double default=NAN )}&store its value in var (optional)\\ \hline
   {\bf\orange   bool } & {\bf\orange CommonExperimentClassRelations} & true if common experiment \\
   & {\bf\orange ~~~~~(PaxVertex* v)} & class instances exist \\  \hline
   {\bf\orange   void } & {\bf\orange    copy(PaxVertex* v)            } &deep copy\\  \hline
   {\bf\orange  ABC* } & {\bf\orange findPointer$<$ABC$>$} & return registered pointer\\
                       & {\bf\orange ~~~~~(``class ABC'', 0)} & of the arbitrary class ABC\\  \hline
   {\bf\orange  double } & {\bf\orange findUserRecord(string s, double default=NAN)} & find value in user record\\  \hline
   {\bf\orange   PaxCollisionRelations*} & {\bf\orange getCollisionRelations() } & get container of collision rel. \\  \hline
   {\bf\orange\tiny PaxIncomingFourVectorRelations*} & {\bf\orange getIncomingFourVectorRelations()} & get container of \\
   & & incoming fourvectors \\   \hline
   {\bf\orange\tiny PaxOutgoingFourVectorRelations*} & {\bf\orange getOutgoingFourVectorRelations()} & get container of \\
   & & outgoing fourvectors \\   \hline
   {\bf\orange   int }&{\bf\orange       getPaxId()             } & get PAX id of this instance\\  \hline
   {\bf\orange   string }&{\bf\orange    getPaxName()            } & get vertex name \\  \hline
   {\bf\orange   int    }&{\bf\orange    getStatus()          } & get status word, e.g. used \\
   & & by monte carlo generators\\  \hline
   {\bf\orange   PaxUserRecord*         } & {\bf\orange getUserRecords() }& get container of user records\\  \hline
   {\bf\orange   PaxVertexRelations*    } & {\bf\orange getVertexRelations()    } & get container of vertices rel.\\   \hline
   {\bf\orange   int   } & {\bf\orange    getWorkflag()   } & get temporary work flag \\ 
   \hline
   \end{tabular}
}   
\end{center}
\end{table}   

\begin{table}[hhh]
\begin{center}
\caption{More member functions of class PaxVertex}
\label{Member functions of PaxVertex 2}
\footnotesize{ %!
 \begin{tabular}{|ll|l|}
	\hline
\multicolumn{1}{|c|}{type}&\multicolumn{1}{c|}{name}&\multicolumn{1}{c|}{description }\\ 
   \hline \hline
   {\bf\orange   bool}&{\bf\orange IsLocked()              } & returns true if vertex is locked\\  \hline
   {\bf\orange   void}&{\bf\orange lock()                  } & lock vertex, related vertices, outgoing fourvectors\\  \hline
   &{\bf\orange PaxVertex  } & constructor\\  \hline
   &{\bf\orange PaxVertex(PaxVertex* v)  } & constructor copying vertex v\\  \hline
   &{\bf\orange PaxVertex(ThreeVector* t)  } & construct from a threevector (e.g. Hep3Vector in CLHEP case)\\ \hline
   &{\bf\orange $\sim$PaxVertex  } & destructor\\  \hline
   {\bf\orange   void}&{\bf\orange print(int level)            } & print vertex attributes: print level (see~\ref{printlevel})\\  \hline
   {\bf\orange   void}&{\bf\orange printDecayTree(int level)   }& print decay tree of PaxVertex: print level (see~\ref{printlevel})\\  \hline
   {\bf\orange  void } & {\bf\orange removeUserRecord( string s )} & remove (string,double) pair from user record\\  \hline
   {\bf\orange   void   }&{\bf\orange    setPaxName(string s)    } & set vertex name \\  \hline
   {\bf\orange   void   }&{\bf\orange    setStatus(int s)     } & set status word, e.g. used by monte carlo generators\\  \hline
   {\bf\orange  void } & {\bf\orange setUserRecord( string s, double d )} & set (string,double) pair in user record\\  \hline
   {\bf\orange   void   } & {\bf\orange    setWorkflag(int i)   } & set temporary work flag \\  \hline
   {\bf\orange   void}&{\bf\orange unlock()                } & unlock vertex, related vertices, outgoing fourvectors\\
   \hline
   \end{tabular}
}
\end{center}
\end{table}   

\subsection{\large Operators for the class PaxVertex}
A table of available member operators for the class PaxVertex is shown in Table~\ref{member operators for class PaxVertex}, while the available non-member operators are shown in Table~\ref{non-member operators for class PaxVertex}.

\begin{table}[hhh]
\begin{center}
\caption{Member operators for the class PaxVertex}
\label{member operators for class PaxVertex}
\footnotesize{ %!
 \begin{tabular}{|ll|l|}
	\hline
\multicolumn{1}{|c|}{type}&\multicolumn{1}{c|}{operator}&\multicolumn{1}{c|}{description }\\ 
   \hline \hline
   {\bf\orange   const PaxVertex\&}&{\bf\orange operator+=(const PaxVertex\& vx)} & increment operator, refers to vector components\\  \hline
   {\bf\orange   const PaxVertex\&}&{\bf\orange operator-=(const PaxVertex\& vx)} & decrement operator, refers to vector components\\  \hline
   \end{tabular}
}
\end{center}
\end{table}   


\begin{table}[hhh]
\begin{center}
\caption{Non-member operators for the class PaxVertex}
\label{non-member operators for class PaxVertex}
\footnotesize{ %!
 \begin{tabular}{|ll|l|}
	\hline
\multicolumn{1}{|c|}{type}&\multicolumn{1}{c|}{operator}&\multicolumn{1}{c|}{description }\\ 
   \hline \hline
   {\bf\orange   const bool}&{\bf\orange operator==(const PaxVertex\& vx1, const PaxVertex\& vx2)} & equality operator, refers to vector components\\  \hline
   {\bf\orange   const bool}&{\bf\orange operator!=(const PaxVertex\& vx1, const PaxVertex\& vx2)} & inequality operator, refers to vector components\\  \hline
   {\bf\orange   ostream\&}&{\bf\orange operator$<<$(ostream\& os, const PaxVertex\& vx)} & streaming operator\\  \hline
   \end{tabular}
}
\end{center}
\end{table}   



\subsection{\large Fill PaxVertex and its relations}

\noindent
// make vertex and add vertex to event interpretation\\
{\bf\red   PaxVertex* v = event$\_$interpret--$>$create$<$PaxVertex$>$(); } \\
\\
Filling of the PaxVertex v is done by setFunctions \\
{\bf\red
      v--$>$setX(x);\\
      v--$>$setY(y);\\
      v--$>$setZ(z);\\
\\
      string s = "primary vertex"; \\
      v--$>$setPaxName(s);\\
}
\\
A relation to another PaxVertex w  (Fig.~\ref{fig:relation1}) is stored by \\
{\bf\red v--$>$getVertexRelations()--$>$add(w);}\\
\\
The relation to a PaxFourVector fi originating from this vertex is stored by \\
{\bf\red v--$>$getOutgoingFourVectorRelations()--$>$add(v,fi);}\\
\\
The relation to a PaxFourVector fo incoming to this vertex is stored by \\
{\bf\red v--$>$getIncomingFourVectorRelations()--$>$add(v,fo);}\\
\\
The relation to a PaxCollision c is stored by\\
{\bf\red v--$>$getCollisionRelations()--$>$add(c,v);}\\
\\
Register the pointer to the instance of an arbitrary detector class DetVertex with the PaxVertex v 
in slot 24 \\
{\bf\red   DetVertex* p = ...; } \\
{\bf\red   v--$>$addPointer$<$DetVertex$>$(``class DetVertex'', 24, p); } \\
\\
For filling a user record see below 
section~\ref{sec:vertex user records}.

\subsection{\large Access to PaxVertex and its relations}

\noindent
To access information of the PaxVertex v use the member functions
described in Tables~\ref{Member functions of PaxVertex 1} and
\ref{Member functions of PaxVertex 2}.
Examples are the x-, y-, z-coordinate of the vertex\\
{\bf\red
v--$>$x();\\
v--$>$y();\\
v--$>$z();\\
}
\\
// To print all information of the vertex v\\
{\bf\red v--$>$print(); }\\
\\
To print only the PaxVertex instances related 
to v get the iterator for the PaxVertex relations\\
{\bf\red PaxIterator$<${\blue PaxVertex}* $>$* 
iter = v--$>${\blue getVertexRelations()}--$>$getIterator();\\
for ( iter--$>$First(); 
!iter--$>$IsDone(); 
iter--$>$Next() )\{ } \\
{\bf\red ~~~iter--$>$CurrentItem()--$>$print(); \\
\}\\
}
\\
To access the transverse momentum of fourvectors originating
from the vertex via the PaxOutgoingFourVectorRelations use\\
{\bf\red 
PaxIterator$<${\blue PaxFourVector}* $>$* 
iter = \\ v--$>${\blue getOutgoingFourVectorRelations()}--$>$getIterator();\\
for ( iter--$>$First(); 
!iter--$>$IsDone(); 
iter--$>$Next() ) \{ }\\
{\bf\red~~~iter--$>$CurrentItem()--$>$perp(); \\
\}\\
}
\\
To access the pseudo-rapidity of a fourvector incoming to
the vertex \\ via the PaxIncomingFourVectorRelations use\\
{\bf\red 
PaxIterator$<${\blue PaxFourVector}* $>$* 
iter = \\ v--$>${\blue getIncomingFourVectorRelations()}--$>$getIterator();\\
for ( iter--$>$First(); 
!iter--$>$IsDone(); 
iter--$>$Next() ) \{ }\\
{\bf\red~~~iter--$>$CurrentItem()--$>$eta(); \\
\}\\
}
Note that we left this open to many-to-many relations since some event
generators allow for two mother particles and therefore two vertices.\\
\\
To access the original detector class instances of PaxVertex v \\
// check whether a pointer to an instance of the arbitrary class DetVertex\\
//  has been registered in slot 24 \\
{\bf\red   DetVertex* p = v--$>$findPointer$<$DetVertex$>$(``class DetVertex'', 24); } \\
// access member function printChi2() of class DetVertex \\
{\bf\red   if ( p ) p--$>$printChi2(); }
\\
For access to the user records see below 
section~\ref{sec:vertex user records}.



\subsection{\large Exclude, re-include PaxVertex \label{lock vertex} }

\noindent
The lock mechanism is used to exclude a vertex from the analysis
together with fourvectors originating from this vertex.
An example is shown on the right side of Fig.~\ref{fig:collisions2}.
The lock command of a PaxVertex v\\
{\bf\red v--$>$lock();}\\
sets the lock flag for v and for all related PaxVertex instances
registered in PaxVertexRelations of v.
It also excludes all related PaxFourVector instances registered in
getOutgoingFourVectorRelations() and their related PaxFourVectors.
In this way, a PaxVertex and all dependent PaxFourVector instances are
automatically excluded in all
event interpretations which exist at the time the command is issued.
A typical command syntax to check for unlocked PaxVertex instances w is\\
{\bf\red if ( !w--$>$IsLocked() ) ...}\\
\\
Unlocking the PaxVertex v is done by\\
{\bf\red v--$>$unlock();}\\
It unsets the lock flag for v and all PaxFourVector and PaxVertex instances
related to v in PaxVertexRelations and in 
getOutgoingFourVectorRelations() at the time the command is issued.

\subsection{\large User records  \label{sec:vertex user records}}

\noindent
The user can store additional information on the PaxVertex v using the
PaxUserRecord facility.
It consists of a map  with key {\em string} and 
mapped type {\em double} which can be searched correspondingly.
The command syntax to fill the information under the name ``myexpression'' is\\
{\bf\red v--$>$setUserRecord( "myexpression", 0.456 );}\\
\\
Retrieving the information works through a search.
It returns either the corresponding value for the key or throws an exception in case no user record was found \\
{\bf\red double value = v--$>$findUserRecord( "myexpression" );} \\
It is possible to provide a default value which is then returned instead of the exception, in case no user record was found:\\
{\bf\red 
double default = 999.;}\\
{\bf\red double value = v--$>$findUserRecord( "myexpression" , default);} \\
Another possibilty is to check, whether a user record exists:\\
{\bf\red bool IsUR = v--$>$checkUserRecord( "myexpression");} \\
\\
For removing a user record use \\
{\bf\red v--$>$removeUserRecord(  "myexpression" );}\\
\\
Direct access to the user records container is given by \\
{\bf\red PaxUserRecord* ur = v--$>$getUserRecords();}


\newpage
\section{\large The class PaxFourVector}

\noindent
The class PaxFourVector holds reconstructed objects such as tracks, 
clusters, jets, electrons etc. as fourvectors.
The base class of PaxFourVector can be chosen to be the {\bf\blue ROOT} library 
{\bf\blue TLorentzVector} which makes the entire functionality of this
ROOT class available to the user (compiler flag \mbox{{\bf\blue PAX$\_$ROOT}}).
Without setting this flag, the {\bf\blue HepLorentzVector} of the
{\bf\blue CLHEP} library is used.

In addition to the ROOT, or CLHEP functionality, PaxFourVector offers storage 
for different information needed during analysis.
Examples are related fourvectors, vertex connection
-- begin vertex and end vertex if exists --, the collision, 
and related instances of the original classes of the experiment.
Furthermore, the user can store analysis dependent results 
in a map with key {\em string} and mapped type {\em double} which 
can be searched correspondingly.
This map is also used by algorithms to store additional information.

\noindent
A PaxFourVector is always booked on the heap.
If you intend to create them within an event interpretation event$\_$interpret 
we recommend to use \\
{\bf\red   PaxFourVector* f = event$\_$interpret--$>$create$<$PaxFourVector$>$(); } \\
or the copy constructor \\
{\bf\red   PaxFourVector* f1 = event$\_$interpret--$>$create$<$PaxFourVector$>$(f); } \\
\\
The ``create'' function provides a shortcut using the available constructor calls \\
{\bf\red       PaxFourVector* f = new PaxFourVector;}\\
or the copy constructor \\
{\bf\red       PaxFourVector* f1 = new PaxFourVector(f);}\\
together with the add() function which is used to register the vertex
in the event interpretation.
Note that every PaxFourVector which has been registered in an instance of PaxEventInterpret,
e.g. event$\_$interpret, by 
\mbox{PaxFourVector* f = event$\_$interpret--$>$create$<$PaxFourVector$>$()} or 
\mbox{event$\_$interpret--$>$add(f)}
is automatically deleted when calling \\
{\bf\red delete event$\_$interpret;}\\
Since a PaxFourVector instance does not know its PaxEventInterpret instance
do not delete a PaxFourVector instance registered by 
event$\_$interpret--$>$add(f), or --$>$create$<$PaxFourVector$>$() yourself. 


\subsection{\large PaxFourVector members and relations}

\noindent
In Tables~
\ref{Member functions of PaxFourVector1},
\ref{Member functions of PaxFourVector4},
\ref{Member functions of PaxFourVector2} and
\ref{Member functions of PaxFourVector3}, member functions 
for the class PaxFourVector are shown.
If the compiler flag PAX$\_$ROOT is set,
the full functionality of the ROOT class TLorentzVector is
available where the most important functions are mentioned
in Table~\ref{Member functions of PaxFourVector1}.
Otherwise the full functionality of the CLHEP class HepLorentzVector is
available where the most important functions are mentioned
in Table~\ref{Member functions of PaxFourVector4}.
Refer to their user guides for more information.
All member functions offered by PAX in addition are shown in Table~
\ref{Member functions of PaxFourVector2} and
\ref{Member functions of PaxFourVector3}.
Fig.~\ref{fig:relation1} displays the relations of
collisions, vertices and fourvectors.


\begin{table}[hhh]
\begin{center}
\caption{Member functions of class PaxFourVector if the ROOT library is used
(compiler flag PAX$\_$ROOT)}
\label{Member functions of PaxFourVector1}
\footnotesize{ %!
   \begin{tabular}{|ll|l|}
	\hline
\multicolumn{1}{|c|}{type}&\multicolumn{1}{c|}{name}&\multicolumn{1}{c|}{description }\\ 
   \hline \hline
   {\bf\orange double}&{\bf\orange E()   }& get energy \\ \hline
   {\bf\orange double}&{\bf\orange Px()  }& get momentum projection onto x-axis \\ 
   {\bf\orange double}&{\bf\orange Py()  }& get momentum projection onto y-axis \\ 
   {\bf\orange double}&{\bf\orange Pz()  }& get momentum projection onto z-axis \\ \hline
   {\bf\orange double}&{\bf\orange Eta() }& get pseudo-rapidity \\  
   {\bf\orange double}&{\bf\orange Pt()  }& get transverse momentum (px,py)\\
   {\bf\orange double}&{\bf\orange Phi() }& get azimuthal direction \\ \hline
   {\bf\orange double}&{\bf\orange Mag() }& get mass \\ 
   \hline
   {\bf\orange void}&{\bf\orange SetE(double e)  }& set energy \\ \hline
   {\bf\orange void}&{\bf\orange SetPx(double px)}& set momentum projection onto x-axis \\ 
   {\bf\orange void}&{\bf\orange SetPy(double py)}& set momentum projection onto y-axis \\ 
   {\bf\orange void}&{\bf\orange SetPz(double pz)}& set momentum projection onto z-axis \\ \hline
   {\bf\orange ... }&{\bf\orange ...ROOT library}& all functionality of TLorentzVector \\  
   \hline
   \end{tabular}
}   
\end{center}
\end{table}   



\begin{table}[hhh]
\begin{center}
\caption{Member functions of class PaxFourVector of the CLHEP library
(no compiler flag PAX$\_$ROOT set)}
\label{Member functions of PaxFourVector4}
\footnotesize{ %!
   \begin{tabular}{|ll|l|}
	\hline
\multicolumn{1}{|c|}{type}&\multicolumn{1}{c|}{name}&\multicolumn{1}{c|}{description }\\ 
   \hline \hline
   {\bf\orange double}&{\bf\orange e()   }& get energy \\ \hline
   {\bf\orange double}&{\bf\orange px()  }& get momentum projection onto x-axis \\ 
   {\bf\orange double}&{\bf\orange py()  }& get momentum projection onto y-axis \\
   {\bf\orange double}&{\bf\orange pz()  }& get momentum projection onto z-axis \\ \hline
   {\bf\orange double}&{\bf\orange eta() }& get pseudo-rapidity \\ 
   {\bf\orange double}&{\bf\orange perp()  }& get transverse momentum (px,py)\\
   {\bf\orange double}&{\bf\orange phi() }& get azimuthal direction \\ \hline
   {\bf\orange double}&{\bf\orange mag() }& get mass \\
   \hline
   {\bf\orange void}&{\bf\orange setE(double e)  }& set energy \\ \hline
   {\bf\orange void}&{\bf\orange setPx(double px)}& set momentum projection onto x-axis \\
   {\bf\orange void}&{\bf\orange setPy(double py)}& set momentum projection onto y-axis \\
   {\bf\orange void}&{\bf\orange setPz(double pz)}& set momentum projection onto z-axis \\ \hline
   {\bf\orange ...   }&{\bf\orange ...CLHEP library}& all functionality of HepLorentzVector \\
   \hline
   \end{tabular}
}
\end{center}
\end{table}   


\begin{table}[hhh]
\begin{center}
\caption{More member functions of class PaxFourVector}
\label{Member functions of PaxFourVector2}
\footnotesize{ %!
   \begin{tabular}{|ll|l|}
	\hline
\multicolumn{1}{|c|}{type}&\multicolumn{1}{c|}{name}&\multicolumn{1}{c|}{description }\\ 
   \hline \hline
   {\bf\orange  void } & {\bf\orange add(string s, double value )} & add (string,double) pair \\
   & & to user records\\   \hline
   {\bf\orange  void } & {\bf\orange  addExperimentClassRelations} & add experiment class instances \\
   & {\bf\orange ~~~~~(PaxFourVector* f )} & of fourvector f \\  \hline
   {\bf\orange  void } & {\bf\orange addPointer$<$ABC$>$} & register pointer q of \\
   & {\bf\orange ~~~~(``class ABC'', 0, q )} & an arbitrary class ABC\\  \hline
   {\bf\orange  bool } & {\bf\orange checkUserRecord( string key,} & check if user record exists and \\
   & {\bf\orange ~~~~double* var=0, double default=NAN )}&store its value in var (optional)\\ \hline
   {\bf\orange   bool } & {\bf\orange CommonExperimentClassRelations} & true if common experiment \\
   & {\bf\orange ~~~~~(PaxFourVector* f)   } & class instances exist\\  \hline
   {\bf\orange   void } & {\bf\orange    copy(PaxFourVector* f) } &deep copy\\  \hline
   {\bf\orange   void } & {\bf\orange findDaughters} & \\
   & {\bf\orange ~~~~~(PaxFourVectorMap* L) } & find all daughter fourvectors\\  \hline
   {\bf\orange   void } & {\bf\orange findDirectDaughters } & \\
   & {\bf\orange ~~~~~(PaxFourVectorMap* L) } & find direct daughter fourvectors\\  \hline
   {\bf\orange  ABC* } & {\bf\orange findPointer$<$ABC$>$} & return registered pointer\\
   & {\bf\orange ~~~~~(``class ABC'', 0)} & of the arbitrary class ABC\\  \hline
   {\bf\orange   void } & {\bf\orange findStableDaughters} & \\
   & {\bf\orange ~~~~~(PaxFourVectorMap* L) } & find stable daughter fourvectors\\  \hline
   {\bf\orange {\small\orange PaxFourVector*}}&{\bf\orange findDirectMother()  }& find mother fourvector\\  \hline
   {\bf\orange {\small\orange PaxFourVector*}}&{\bf\orange findOriginalMother()}& find original mother fourvector\\  \hline
   {\bf\orange  void } & {\bf\orange findUserRecord(string s,} & find value in user record\\ 
&{\bf\orange ~~~~double default=NAN )} &\\ \hline
   {\bf\orange   PaxBeginVertexRelations*    } & {\bf\orange getBeginVertexRelations()    } & get container of begin vertex rel.\\   \hline
   {\bf\orange {\small\orange PaxFourVector*}}&{\bf\orange getBoostVector() }& if this instance is boosted \\
   & & get boost PaxFourVector*\\  \hline
   {\bf\orange   double }&{\bf\orange    getCharge()          }& get charge\\  \hline
   {\bf\orange   PaxCollisionRelations* } & {\bf\orange getCollisionRelations() } & get container of collision rel. \\  \hline
   {\bf\orange   PaxEndVertexRelations*    } & {\bf\orange getEndVertexRelations()    } & get container of end vertex rel.\\   \hline
   {\bf\orange   PaxFourVectorRelations*} & {\bf\orange getFourVectorRelations()} & get container of fourvectors rel. \\   \hline
   {\bf\orange   int }&{\bf\orange       getPaxId()             }& get PAX id of this instance\\  \hline
   {\bf\orange   double }&{\bf\orange       getMass()            }& get mass\\  \hline
   {\bf\orange   string }&{\bf\orange    getPaxName()            }& get PaxFourVector name \\  \hline
   {\bf\orange   int    }&{\bf\orange    getParticleId()      }& get particle code a la PDG\\  \hline
   {\bf\orange   int    }&{\bf\orange    getSimulated()       }& simulated particle flag\\  \hline
   {\bf\orange   int    }&{\bf\orange    getStatus()          }& get status word, e.g. used \\  
   & & by monte carlo generators\\  \hline
   {\bf\orange   PaxUserRecord*         } & {\bf\orange getUserRecords() }& get container of user records\\  \hline
   {\bf\orange   int   } & {\bf\orange    getWorkflag()   } & get temporary work flag \\ 
   \hline
   \end{tabular}
}   
\end{center}
\end{table}   


\begin{table}[hhh]
\begin{center}
\caption{More member functions of class PaxFourVector}
\label{Member functions of PaxFourVector3}
\footnotesize{ %!
   \begin{tabular}{|ll|l|}
	\hline
\multicolumn{1}{|c|}{type}&\multicolumn{1}{c|}{name}&\multicolumn{1}{c|}{description }\\ 
   \hline \hline
   {\bf\orange   bool}&{\bf\orange IsLocked()              }& returns true if PaxFourVector is locked\\   \hline
   {\bf\orange   void}&{\bf\orange lock()                  }& lock PaxFourVector, related PaxFourVectors, \\ 
   && related begin vertices\\  \hline
   &{\bf\orange  PaxFourVector      }&constructor  \\   \hline
   &{\bf\orange  PaxFourVector(PaxFourVector* f)      }&constructor copying fourvector f \\   \hline
   &{\bf\orange  PaxFourVector(LorentzVector* l) }&construct from a lorentz-vector (e.g. HepLorentzVector\\
   && in CLHEP case) \\ \hline
   &{\bf\orange  PaxFourVector(PaxVertex* v) }&construct from a PaxVertex. The kinematics are calculated \\
   &&according to the outgoing vectors at the vertex. \\ \hline
   &{\bf\orange  $\sim$PaxFourVector      }&destructor  \\   \hline
   {\bf\orange   void}&{\bf\orange print(int level)            }& print PaxFourVector attributes \\
   && print level (see~\ref{printlevel})\\  \hline
   {\bf\orange   void}&{\bf\orange printDecayTree(int level)   }& print decay tree of PaxFourVector\\
   && print level (see~\ref{printlevel})\\  \hline
   {\bf\orange  void } & {\bf\orange removeUserRecord( string s )} & remove (string,double) pair from user record\\  \hline
   {\bf\orange   void   }&{\bf\orange    setBoostVector(PaxFourVector* b)  
                                           }& if PaxFourVector is boosted \\
   &&set boost PaxFourVector\\  \hline
   {\bf\orange   void  }&{\bf\orange     setCharge(double c)  }& set charge\\  \hline
   {\bf\orange   void}&{\bf\orange       setMass(double m)    }& set mass, changes energy as well\\  \hline
   {\bf\orange   void   }&{\bf\orange    setPaxName(string s)    }& set PaxFourVector name \\  \hline
   {\bf\orange   void   }&{\bf\orange    setParticleId(int id)}& set particle code ala Particle Data Group\\  \hline
   {\bf\orange   void   }&{\bf\orange    setSimulated(string s)}& set monte carlo generated or simulated particle \\  \hline
   {\bf\orange   void   }&{\bf\orange    setStatus(int s)     }& set status word, \\
   &&e.g. used by monte carlo generators\\  \hline
   {\bf\orange  void } & {\bf\orange setUserRecord( string s, double d )} & set (string,double) pair in user record\\  \hline
   {\bf\orange   void   } & {\bf\orange    setWorkflag(int i)   } & set temporary work flag \\  \hline
   {\bf\orange   void}&{\bf\orange unlock()                }& unlock PaxFourVector, related PaxFourVectors, \\
   && begin vertices\\ 
   \hline
   \end{tabular}
}   
\end{center}
\end{table}   

\subsection{\large Operators for the class PaxFourVector}
A table of available member operators for the class PaxFourVector is shown in Table~\ref{member operators for class PaxFourVector}, while the available non-member operators are shown in Table~\ref{non-member operators for class PaxFourVector}.

\begin{table}[hhh]
\begin{center}
\caption{Member operators for the class PaxFourVector}
\label{member operators for class PaxFourVector}
\footnotesize{ %!
 \begin{tabular}{|ll|l|}
	\hline
\multicolumn{1}{|c|}{type}&\multicolumn{1}{c|}{operator}&\multicolumn{1}{c|}{description }\\ 
   \hline \hline
   {\bf\orange   const PaxFourVector\&}&{\bf\orange operator+=(const PaxFourVector\& f)} & increment operator, \\
	& &refers to vector components and charge\\  \hline
   {\bf\orange   const PaxFourVector\&}&{\bf\orange operator-=(const PaxFourVector\& f)} & decrement operator, \\
	& &refers to vector components and charge\\  \hline
   \end{tabular}
}
\end{center}
\end{table}   


\begin{table}[hhh]
\begin{center}
\caption{Non-member operators for the class PaxFourVector}
\label{non-member operators for class PaxFourVector}
\footnotesize{ %!
 \begin{tabular}{|ll|l|}
	\hline
\multicolumn{1}{|c|}{type}&\multicolumn{1}{c|}{operator}&\multicolumn{1}{c|}{description }\\ 
   \hline \hline
   {\bf\orange   const bool}&{\bf\orange operator==(const PaxFourVector\& f1, const PaxFourVector\& f2)} & equality operator, refers to\\  
	& &vector components and charge\\  \hline
   {\bf\orange   const bool}&{\bf\orange operator!=(const PaxFourVector\& f1, const PaxFourVector\& f2)} & inequality operator, refers to\\ 
	& &vector components and charge\\  \hline
   {\bf\orange   ostream\&}&{\bf\orange operator$<<$(ostream\& os, const PaxFourVector\& f)} & streaming operator\\  \hline
   \end{tabular}
}
\end{center}
\end{table}   






\subsection{\large Fill PaxFourVector and its relations}

\noindent
// make fourvector and add fourvector to event interpretation\\
{\bf\red   PaxFourVector* f = event$\_$interpret--$>$create$<$PaxFourVector$>$(); } \\
\\
Filling of the PaxFourVector f is done by setFunctions \\
{\bf\red
      f--$>$setPx(px);\\
      f--$>$setPy(py);\\
      f--$>$setPz(pz);\\
      f--$>$setE (e);\\
\\
      string s = "pion"; \\
      f--$>$setPaxName(s);\\
}
\\
A relation to another PaxFourVector g  (Fig.~\ref{fig:relation1}) is stored by \\
{\bf\red f--$>$getFourVectorRelations()--$>$add(g);}\\
\\
The relation to the begin vertex v is stored by \\
{\bf\red f--$>$getBeginVertexRelations()--$>$add(v,f);}\\
\\
The relation to the end vertex w is stored by \\
{\bf\red f--$>$getEndVertexRelations()--$>$add(w,f);}\\
\\
The relation to a collision c is stored by\\
{\bf\red f--$>$getCollisionRelations()--$>$add(c,f);}\\
\\
Register the pointer to the instance of an arbitrary detector class DetElectron with the PaxFourVector f
in slot 156 \\
{\bf\red   DetElectron* p = ...; } \\
{\bf\red   f--$>$addPointer$<$DetElectron$>$(``class DetElectron'', 156, p); } \\
\\
For filling a user record see below 
section~\ref{sec:fourvector user records}.

\subsection{\large Access PaxFourVector and its relations}

\noindent
To access information of the PaxFourVector f use the member functions
described in Tables~\ref{Member functions of PaxFourVector1}
and \ref{Member functions of PaxFourVector2}.
Examples are the transverse momentum, the pseudo-rapidity and
the azimuthal direction\\
\bredb{f--$>$perp();}\\
\bredb{f--$>$eta();}\\
\bredb{f--$>$phi();}\\
\\
// To print all information on the fourvector f \\
{\bf\red f--$>$print(); }\\
\\
To print only the PaxFourVector instances related 
to f get the iterator for the getFourVectorRelations() (Fig.~\ref{fig:relation1})\\
{\bf\red PaxIterator$<${\blue PaxFourVector}* $>$* 
iter = f--$>${\blue getFourVectorRelations()}--$>$getIterator();\\
for ( iter--$>$First(); 
!iter--$>$IsDone(); 
iter--$>$Next() ) \{ }\\
{\bf\red~~~iter--$>$CurrentItem()--$>$print(); \\
\}\\
}
\\
To access the z-coordinate of the begin vertex of f via the 
getBeginVertexRelations() use\\
{\bf\red PaxIterator$<${\blue PaxVertex}* $>$* 
iter = f--$>${\blue getBeginVertexRelations()}--$>$getIterator();\\
for ( iter--$>$First(); 
!iter--$>$IsDone(); 
iter--$>$Next() ) \{ }\\
{\bf\red~~~iter--$>$CurrentItem()--$>$z(); \\ \}
}\\
Note that we left this open to many-to-many relations since some event
generators allow for two mother particles and therefore two vertices.
\\
\\
To access the z-coordinate of the end vertex of f via the 
getEndVertexRelations() use\\
{\bf\red PaxIterator$<${\blue PaxVertex}* $>$* 
iter = f--$>${\blue getEndVertexRelations()}--$>$getIterator();\\
for ( iter--$>$First(); 
!iter--$>$IsDone(); 
iter--$>$Next() ) \{ }\\
{\bf\red~~~iter--$>$CurrentItem()--$>$z();\\
\}
} \\
Note that we left this open to many-to-many relations since some event
generators allow for two mother particles and therefore two vertices.
\\
\\
To access the original detector class instances of PaxFourVector f \\
// check whether a pointer to an instance of the arbitrary class DetElectron\\
// has been registered in slot 156 \\
{\bf\red   DetElectron* p = f--$>$findPointer$<$DetElectron$>$(``class DetElectron'', 156); } \\
// access member function printChi2() of class DetElectron \\
{\bf\red   if ( p ) p--$>$printChi2(); } \\
\\
For access to the user records see below 
section~\ref{sec:fourvector user records}.

\subsection{\large Exclude, re-include PaxFourVector \label{lock fourvector}}

\noindent
The lock mechanism is used to exclude a fourvector from the analysis.
A visualization of the exclusion mechanism is shown in Fig.~\ref{fig:collisions2}.
An example is an isolated electron which the user does not want
to not be used by a jet finding algorithm.
The lock command of a PaxFourVector f\\
{\bf\red f--$>$lock();}\\
sets the lock flag for f and for all related PaxFourVector instances
registered in getFourVectorRelations() of f.
It also excludes  all dependent PaxVertex instances registered in
getEndVertexRelations() and their related PaxFourVectors.
In this way, a PaxFourVector and all dependent PaxVertex and PaxFourVector 
instances are automatically excluded in all
event interpretations which exist at the time the command is issued.
A typical command syntax to check for unlocked PaxFourVector instances g is\\
{\bf\red if ( !g--$>$IsLocked() ) ...}\\
\\
Unlocking the PaxFourVector f is done by\\
{\bf\red f--$>$unlock();}\\
It unsets the lock flag for f and all PaxFourVector and PaxVertex instances
related to f in getFourVectorRelations() and in
getEndVertexRelations() at the time the command is issued.


\subsection{\large User records \label{sec:fourvector user records}}

\noindent
The user can store additional information on the PaxFourVector f using the
PaxUserRecord facility.
It consists of a map  with key {\em string} and 
mapped type {\em double} which can be searched correspondingly.
The command syntax to fill the information under the name ``myexpression'' is\\
{\bf\red f--$>$setUserRecord( "myexpression", 0.456 );}\\
\\
Retrieving the information works through a search.
It returns either the corresponding value for the key or throws an exception in case no user record was found \\
{\bf\red double value = f--$>$findUserRecord( "myexpression" );} \\
It is possible to provide a default value which is then returned instead of the exception, in case no user record was found:\\
{\bf\red 
double default = 999.;}\\
{\bf\red double value = f--$>$findUserRecord( "myexpression" , default);} \\
Another possibilty is to check, whether a user record exists:\\
{\bf\red bool IsUR = f--$>$checkUserRecord( "myexpression");} \\
\\
For removing a user record use \\
{\bf\red f--$>$removeUserRecord(  "myexpression" );}\\
\\
Direct access to the user records container is given by \\
{\bf\red PaxUserRecord* ur = f--$>$getUserRecords();}


\newpage
\section{\large The classes PaxExperiment and PaxExperimentClass \label{sec:experiment class}}

\noindent
In order to recover original information leading, e.g. to PAX fourvectors,
pointers to instances of the reconstruction classes of the experiment are stored.
As we don't know the details of these classes, the template class PaxExperiment
has been introduced which remembers this pointer.
This template class inherits from the base class PaxExperimentClass with
the latter enabling registration in the containers of PAX collisions, 
vertices, fourvectors.

\noindent
Instances of the class PaxExperiment are always booked on the heap.
The available constructor call with the detector class A and upcast 
to the PaxExperimentClass are \\
{\bf\red PaxExperimentClass* ec = new PaxExperiment$<$A$>$;} \\
{\bf\red PaxExperimentClass* ec = new PaxExperiment$<$A$>$(A* a);} \\
\\
Every PaxExperimentClass instance which has been registered in 
a relation manager of a PaxCollision, PaxVertex, or PaxFourVector instance
(details below), is automatically deleted when calling the corresponding\\
{\bf\red delete event$\_$interpret;}


\subsection{\large Members of template class PaxExperiment}

\noindent
The template class PaxExperiment$<$A$>$ remembers the pointer to the instance
of the detector class A.
The pointer can be accessed through {\em\bf\blue getData()}.

\subsection{\large Fill pointer to original detector class }

\noindent
We take the detector class SiTrack as example and get the
pointer to the original instance\\
{\bf\red SiTrack* d19 = ...;} \\
To fill the pointer to the original detector class instances of, e.g. 
PaxFourVector f use as a shortcut \\
{\bf\red   f--$>$addPointer$<$SiTrack$>$(``class SiTrack'', 19, d19); } \\
\\
If you urgently want to understand what happens:
a corresponding relation manager is created and registered. \\
// create managers to hold pointers to instances of experiment \\
{\bf\red  PaxExperimentClassRelations* ecr$\_$relation = new PaxExperimentClassRelations;}\\
// register relation manager with fourvector\\
{\bf\red  string s = "SiTrack";}\\
{\bf\red  f--$>$getExperimentClassRelations()--$>$add( s, ecr$\_$relation );}\\
// instance of PaxExperimentClass remembers the pointer to instance of SiTrack \\
// and allows for dynamic$\_$cast\\
{\bf\red  PaxExperimentClass* ec = new PaxExperiment$<$SiTrack$>$(d19);}\\
// set the PaxId of this related instance to be \\
// the slot 19 in the experimental class container \\
{\bf\red  ecr$\_$relation--$>$add(19,ec);}


\subsection{\large Access pointer to original detector class \label{sec:access expclass}}

\noindent
To access the original detector class instances of, e.g. PaxFourVector f 
use the following shortcut:\\
// check whether a pointer to an instance of the class SiTrack\\
// has been registered in slot 19 \\
{\bf\red   SiTrack* p = f--$>$findPointer$<$SiTrack$>$(``class SiTrack'', 19); } \\
// access member function printChi2() of class SiTrack \\
{\bf\red   if ( p ) p--$>$printChi2(); } \\
\\
If you urgently want to understand what the complete procedure is: \\
// check whether a relation manager has been registered with the name SiTrack \\
{\bf\red   string s="SiTrack"; } \\
{\bf\red       if ( f--$>$
           getExperimentClassRelations()--$>$findItemByKey( s ))\\
\{ }\\
// define pointer for downcast to detector class \\
{\bf\red~~~PaxExperiment$<$SiTrack$>$* detector; } \\

\noindent
// in general, many instances of SiTrack may be related to f, e.g. in the case of jets.\\
// Get iterator for the experiment class from the Relation Manager\\
{\bf\red~~~PaxIterator$<$PaxExperimentClass* $>$* iter;}\\
{\bf\red~~~iter = f--$>$
            getExperimentClassRelations()--$>$findItemByKey( s )--$>$getIterator(); } \\
\noindent          
// print the eta-phi index, note that EtaPhi() is a member function owned by\\
// the class SiTrack\\
{\bf\red~~~for (iter--$>$First(); !iter--$>$IsDone(); iter--$>$Next() ) } \\
{\bf\red~~~\{ }\\
\noindent
// downcast from pax experimentclass to detector class \\
{\bf\red~~~~~~~detector = dynamic$\_$cast$<$PaxExperiment$<$SiTrack$>$* $>$(iter--$>$CurrentItem()); } \\
\noindent
// access member function of SiTrack \\
{\bf\red~~~~~~~cout  $<<$ "Chi2 = " $<<$ detector--$>$getData()--$>$printChi2() $<<$ endl; } \\
{\bf\red~~~\}\\
\} }



\subsection*{\small (Additional section here, reserved for future use)}
\noindent

\subsection*{\small (Additional section here, reserved for future use)}
\noindent


\newpage
\section{\large Technical details }

\subsection{\large Container and Iterator \label{sec:iterator}}

\noindent
The {\bf\blue container} primarily used in PAX is the map of the C++ Standard Template
Library.
An advantage of this container is access by search for items via keys.
In order to ensure a simple command syntax, e.g. for filling containers,
and to enable warning messages, we introduced the template class PaxMap 
which inherits from map.\\

\noindent
Every class in PAX with a map provides the member function getIterator()
which returns the correct iterator.
To enable multiple nested loops over the identical container, additional
iterators can be received by getIterator(i) with i=0,1,2,...~.
All iterators which were received through getIterator(i) are deleted 
when deleting the corresponding event interpretation.
Every class in PAX with a map also provides the member function 
findItemByKey(string s) which returns a pointer to the searched item,
or 0 if no item was found.

In Table~\ref{Members of PaxMap} member functions of the template class
PaxMap are shown.
\begin{table}[hhh]
\begin{center}
\caption{Members of template class PaxMap which inherits the 
container map of the C++ Standard Library}
\label{Members of PaxMap}
\footnotesize{ %!
   \begin{tabular}{|ll|l|}
	\hline
\multicolumn{1}{|c|}{type}&\multicolumn{1}{c|}{name}&\multicolumn{1}{c|}{description }\\ 
   \hline \hline
   {\bf\orange   void }&{\bf\orange  add(key$\_$type s, mapped$\_$type pl) }& register pair \\  \hline
   {\bf\orange   void }&{\bf\orange  clearmap()                            }& clear map \\  \hline
   {\bf\orange   void }&{\bf\orange  remove(key$\_$type s)                 }& remove pair \\  \hline
   {\bf\orange   int  }&{\bf\orange  getSize()                             }& number of items in map \\
   \hline
   \end{tabular}
}
\end{center}
\end{table}   


\noindent
To enable common command syntax for loops we introduced a template class
PaxIterator which takes the responsibility for the data access.
The {\bf\blue iterator} loop returns a pointer to the objects under consideration, 
e.g. fourvectors, or vertices etc.
The iterator knows the number of items in the container.
The PaxIterator class follows the design pattern ``iterator''
\cite{designpatterns}.

In Table~\ref{Members of PaxIterator} the member functions of the 
template class PaxIterator are shown.
\begin{table}[hhh]
\begin{center}
\caption{Members of template class PaxIterator}
\label{Members of PaxIterator}
\footnotesize{ %!
   \begin{tabular}{|ll|l|}
	\hline
\multicolumn{1}{|c|}{type}&\multicolumn{1}{c|}{name}&\multicolumn{1}{c|}{description }\\ 
   \hline \hline
   {\bf\orange void }&{\bf\orange  First()       }& set the iterator pointer to the first item \\ \hline
   {\bf\orange void }&{\bf\orange  Next()        }& set the iterator pointer to the next item \\ \hline
   {\bf\orange bool }&{\bf\orange  IsDone()      }& true if end of container has been reached \\ \hline
   {\bf\orange ItemType}&{\bf\orange  CurrentItem() }& returns the current item of ItemType\\ \hline
   {\bf\orange void }&{\bf\orange  Goto(PaxIterator$<$ItemType$>$* p ) }& set iterator position to position of another iterator p \\ 
   \hline
   \end{tabular}
}
\end{center}
\end{table}   

\noindent
Every class in PAX with a map provides the member function getIterator()
which returns the correct iterator.
In this way, also nested loops over different physics objects exhibit 
the same syntax.
To enable multiple nested loops over the identical container, additional
iterators can be received by getIterator(i) with i=0,1,2,...\\
// make event interpretation \\
{\bf\red   PaxEventInterpret* tracks = new PaxEventInterpret;}\\
// fill this event interpretation using a fill routine
{\bf\red   MyFillTracks(tracks);}\\
// loop over all combinations of the same container\\
{\bf\red   PaxIterator$<$PaxFourVector* $>$* iter1= 
           tracks--$>$getFourVectors()--$>$getIterator(1);}\\
{\bf\red   PaxIterator$<$PaxFourVector* $>$* iter2= 
           tracks--$>$getFourVectors()--$>$getIterator(2);}\\
{\bf\red   for (iter1--$>$First(); !iter1--$>$IsDone(); iter1--$>$Next()) }\\
{\bf\red   \{ }\\
{\bf\red~~iter2--$>$Goto( iter1 ); iter2--$>$Next(); }\\
{\bf\red~~while ( !iter2--$>$IsDone() ) }\\
{\bf\red~~~\{ }\\
{\bf\red~~~~~iter1--$>$CurrentItem()--$>$px() $\;$*$\;$ iter2--$>$CurrentItem()--$>$px();}\\
{\bf\red~~~~~iter2--$>$Next(); } \\
{\bf\red~~~\}}\\
{\bf\red\} }\\
All iterators which were received through getIterator(), or getIterator(i) 
are deleted when deleting the corresponding event interpretation \\
{\bf\red   delete tracks;} \\
\\
A most simple syntax can be achieved by including the following directive
in your source code (preferably at the beginning of a .cc file) \\
{\bblueb{\# define} \bredb{iterate(iter) for (iter--$>$First(); !iter--$>$IsDone(); iter--$>$Next())}} \\
This allows a clear and very short loop syntax to be coded.
An example is the following loop over all vertices and their fourvectors  \\
// loop over the vertices in the event and print the fourvectors originating from them\\
{\bf\red   PaxIterator$<$PaxVertex* $>$* itervx = tracks--$>$getVertices()--$>$getIterator();}\\
{\bf\red   iterate( itervx ) }\\
{\bf\red      \{ }\\
{\bf\red   ~~PaxIterator$<$PaxFourVector* $>$* iterfv =}\\
{\bf\red   ~~itervx--$>$CurrentItem()--$>$getOutgoingFourVectorRelations()--$>$getIterator();}\\
{\bf\red   ~~iterate( iterfv ) }\\
{\bf\red~~\{ }\\
{\bf\red~~~~iterfv--$>$CurrentItem()--$>$print();}\\
{\bf\red~~\}}\\
{\bf\red \} }
%The iterator shortens the usual iterator syntax when accessing 
%containers of the Standard Template Library.
%Alternatively one can use\\
%{\bf map$<$int,PaxFourVector* $>$::const$\_$iterator iter;}\\
%{\bf for ( iter = track--$>$getFourVectors()--$>$begin();
%iter != track--$>$getFourVectors()--$>$end(); iter++)}\\
%{\bf \{ }\\
%{\bf iter--$>$second--$>$print();}\\
%{\bf \} }\\



\subsection{\large Relation}

\noindent
Relations between fourvectors, or between fourvectors and vertices etc.,
are provided by the class PaxRelationManager which follows 
the design pattern ``mediator'' \cite{designpatterns}
(see Fig.~\ref{fig:relation1}).
The relation manager allows many-to-many relations to be handled which 
are a primary challenge in the physics analysis of an experiment.
One application in PAX is the exclusion mechanism (lock) for fourvectors, vertices,
and collisions.\\

\noindent
In Table~\ref{Members of PaxRelationManager} member functions of the class
PaxRelationManager are shown.
\begin{table}[hhh]
\begin{center}
\caption{Members of template class PaxRelationManager}
\label{Members of PaxRelationManager}
\footnotesize{ %!
   \begin{tabular}{|ll|l|}
	\hline
\multicolumn{1}{|c|}{type}&\multicolumn{1}{c|}{name}&\multicolumn{1}{c|}{description }\\ 
   \hline \hline
   {\bf\orange     void                   }&{\bf\orange add(ItemType w)       }& register object w of class ItemType \\ \hline
   {\bf\orange     ItemType            }&{\bf\orange findItemByKey(KeyType k) }& find pointer to registered relation of\\
&&ItemType by object k of KeyType\\ \hline
   {\bf\orange     PaxIterator$<$ItemType$>$* }&{\bf\orange getPaxIterator() }& return pointer to Iterator of ItemType\\
&&over registered relations \\ \hline
   {\bf\orange     void                   }&{\bf\orange notify(int message) }& notify registered members, e.g. lock \\ \hline
   {\bf\orange     int                    }&{\bf\orange getSize()           }& return number of registered relations \\ \hline 
   {\bf\orange     void                   }&{\bf\orange print()             }& default print relations \\ \hline
   {\bf\orange     void                   }&{\bf\orange print(int level)    }& print relations according to print level (see~\ref{printlevel}) \\ \hline
   {\bf\orange     void                   }&{\bf\orange remove(ItemType w)    }& unregister object w of ItemType\\
   \hline
   \end{tabular}
}   
\end{center}
\end{table}   


\subsection{\large The PAX identifier \label{ssec:PAXidentifier}}
\noindent
The class PaxIdGenerator ensures that each instance of the classes
PaxEventInterpret, PaxCollision, PaxVertex and PaxFourVector receive a PAX identifier for its
record in the container.
The member function generateIntKey() is called at each constructor
call: \\
{\bf\red PaxIdGenerator::Instance()--$>$generateIntKey();}\\
It returns the next free integer value.
The command \\
{\bf\red PaxIdGenerator::Instance()--$>$resetIntKey();} \\
resets the integer counter to zero.
This is recommended to be done at the beginning or end of an event analysis.
PaxIdGenerator follows the design pattern ``singleton'' \cite{designpatterns}.

In Table~\ref{Members of PaxIdGenerator} the member functions of the class
PaxIdGenerator are shown.
\begin{table}[hhh]
\begin{center}
\caption{Members of class PaxIdGenerator}
\label{Members of PaxIdGenerator}
\footnotesize{ %!
  \begin{tabular}{|ll|l|}
	\hline
\multicolumn{1}{|c|}{type}&\multicolumn{1}{c|}{name}&\multicolumn{1}{c|}{description }\\ 
   \hline \hline
   {\bf\orange   int  }&{\bf\orange  generateIntKey()} & return unique integer \\ \hline
   {\bf\orange   void }&{\bf\orange  resetIntKey()   } & reset integer counter \\ 
   \hline
   \end{tabular}
}   
\end{center}
\end{table}   

\subsection{\large Print Levels \label{printlevel}}
\noindent
Five print levels are supported in PAX: \\
\begin{table}[hhh]
\begin{center}
\caption{Print levels}
\label{print levels}
\footnotesize{ %!
   \begin{tabular}{|ll|}
	\hline
\multicolumn{1}{|c|}{option}&\multicolumn{1}{c|}{description}\\
   \hline \hline
   {\bf\orange PAX$\_$DEFAULT} & long debug printout \\ 
   {\bf\orange PAX$\_$SHORT}   & reduced printout \\ 
   \hline
   {\bf\orange PAX$\_$PT}      & long debug printout using pt,eta,phi for the fourvector kinematics \\
   {\bf\orange PAX$\_$PTSHORT} & reduced printout using pt,eta,phi for the fourvector kinematics \\
   \hline
   {\bf\orange PAX$\_$QUIET}   & suppress printout \\
   \hline
   \end{tabular}
}   
\end{center}
\end{table}   


\subsection{\large Write event interpretations to file, read from file \label{sec:store}}

\noindent
Since version 2.00.00, a newer and faster I/O scheme (based on streams) 
for storage of PaxEventInterpret instances is provided. 

\noindent
\emph{Although the prior, ROOT-based I/O scheme is still available, its 
usage is strongly discouraged and existing PAX files should be converted
with the conversion program {\bf\blue paxconvert.cc}, which is available in 
the directory {\bf\blue PAX/test} of the PAX kernel versions 2.00.XX.}

\noindent
Now, the basic class for PAX file access is the typedef PaxIoFile 
(which represents a specialisation of the template class 
PaxIoFileVx$<$...$>$ with the current PAX I/O streaming class, 
e.g. PaxIoStreamerV1).

\noindent
To write out PaxEventInterpret instances, the following 
sequence of commands can be used:

\noindent 
// Create a new file for writing\\
{\bf\red PaxIoFile* iofile = new PaxIoFile("mydata.paxio", PaxIoFile::Write);}\\
// CAUTION: existing files are overwritten\\
%~\\
// Let there be an event loop:\\
{\bf\red for (int event=0; event $<$ 10000; event++)}\\
{\bf\red \{ }\\
%~\\
// Let there be two event interpretations in each event\\
{\bf\red ~~~PaxEventInterpret* ei1 = new PaxEventInterpret;}\\
{\bf\red ~~~PaxEventInterpret* ei2 = new PaxEventInterpret;}\\
%~\\
// which undergo some analysis\\
{\bf\red ~~~...;}\\
%~\\
// one might want to isolate the physics objects relations\\
// (this allows faster reading via readIsolated() later on)\\
//{\bf\red ~ei1--$>$isolate();}\\
//{\bf\red ~ei2--$>$isolate();}\\
%~\\
// to store ei1 and ei2 to the output file buffer use\\
{\bf\red ~~~iofile--$>$store(ei1);}\\
{\bf\red ~~~iofile--$>$store(ei2);}\\
%~\\
// and finally write the event via\\
{\bf\red ~~~iofile--$>$writeEvent();}\\
{\bf\red \} }\\
%~\\
// the delete statement also closes the file\\
{\bf\red delete iofile;}\\

\noindent
To later read in the PaxEventInterpret instances, the following 
sequence of commands can be used:

\noindent 
// Open the existing file for reading\\
{\bf\red PaxIoFile* iofile = new PaxIoFile("mydata.paxio", PaxIoFile::Read);}\\
%~\\
// Skip the first 500 events\\
{\bf\red iofile--$>$skipEvents(500);}\\
%~\\
// Start the event loop\\
{\bf\red while ( !iofile--$>$EndOfFile() )}\\
{\bf\red \{ }\\
// read the event\\
{\bf\red ~~~iofile--$>$readEvent()}\\
%~\\
// If the physics objects relations were isolate at storage time,\\
// one can use the faster readIsolated() method instead\\
//{\bf\red ~iofile--$>$readEventIsolated()}\\
%~\\
// Start the event interpret loop\\
{\bf\red ~~~while ( !iofile--$>$EndOfEvent() )}\\
{\bf\red ~~~\{ }\\
// We prepare an event interpretation for reading\\
{\bf\red ~~~~~~PaxEventInterpret* ei = new PaxEventInterpret;}\\
%~\\
// and read it via\\
{\bf\red ~~~~~~iofile--$>$restore(ei);}\\
%~\\
// this ei might now undergo some further analysis\\
{\bf\red ~~~~~~...;}\\
{\bf\red ~~~\} }\\
{\bf\red \} }\\
%~\\
// the delete statement also closes the file\\
{\bf\red delete iofile;}\\

\noindent
Please note that the unique PAX identifier (see subsection~\ref{ssec:PAXidentifier}) of the instances of PaxEventInterpret, PaxCollision, PaxVertex and PaxFourVector restored from a PaxIoFile differ from the PAX identifiers these objects had, when they were written to disk.
These PAX identifiers are re-generated everytime the object is created in the memory.
Of course it is taken care of those entries in the user record starting with ''\bblueb{id\_}'', stating that an PAX identifier is stored.
These PAX identifiers are set correctly to the generated numbers during the read procedure.\\


\begin{table}[hhh]
\begin{center}
\caption{Members of the typedef PaxIoFile}
\label{Members of PaxIoFile}
\footnotesize{ %!
   \begin{tabular}{|ll|l|}
	\hline
\multicolumn{1}{|c|}{type}&\multicolumn{1}{c|}{name}&\multicolumn{1}{c|}{description }\\ 
   \hline \hline
   {\bf\orange void} & {\bf\orange close()} 		& closes the file, if opened \\   \hline
   {\bf\orange bool} & {\bf\orange EndOfFile()} 	& end of file indicator \\  \hline
   {\bf\orange bool} & {\bf\orange EndOfEvent()} 	& end of event indicator \\  \hline
   {\bf\orange bool} & {\bf\orange open(string filename, int mode)} &  Open file in given mode (PaxIoFileVx::Read, \\   
                     &					&  PaxIoFileVx::Append, or PaxIoFileVx::Write) \\  \hline
   {\bf\orange bool} & {\bf\orange readEventIsolated()} & prepares the subsequent event in the input file \\ 
                     &					& for reading of isolated PaxEventInterprets \\  \hline
   {\bf\orange bool} & {\bf\orange readEvent()} 	& reads and reconstructs the complete subsequent \\
                     &					& event of the input file \\  \hline
		     & {\bf\orange PaxIoFileVx()} 			&  constructor\\  \hline
		     & {\bf\orange PaxIoFileVx(string filename, int mode)} & constructor, calls {\bf\orange open(filename, mode)} \\  \hline
		     & {\bf\orange $\sim$PaxIoFileVx()} 			& destructor, calls {\bf\orange close()}  \\  \hline
   {\bf\orange bool} & {\bf\orange restore(PaxEventInterpret* ei)} & restores the next PaxEventInterpret instance \\  \hline
   {\bf\orange bool} & {\bf\orange restore(PaxEventInterpret* ei,} & restores the next PaxEventInterpret instance \\
                     & {\bf\orange ~~~string ei\_name)} &   with {\bf\orange getPaxName() == ei\_name} \\ \hline
   {\bf\orange bool} & {\bf\orange skipEvent()} 	& skips the following event in the current input file \\ 
                     &					& without reading it \\ \hline
   {\bf\orange bool} & {\bf\orange skipEvents(int n)} 	& skips the following n events in the current input \\
                     &					& file without reading them \\ \hline
   {\bf\orange void} & {\bf\orange skipEventData()} 	& skips the current event data in the input file after \\ 
                     &					& {\bf\orange readEvent()} had been called \\  \hline
   {\bf\orange bool} & {\bf\orange store(PaxEventInterpret* ei)} & stores a PaxEventInterpret instance to the current \\
                     &					&  event buffer of the output file \\  \hline
   {\bf\orange bool} & {\bf\orange writeEvent()} 	& writes the current event buffer physically to the \\
                     & 					&  output file \\ 
   \hline
   \end{tabular}
}
\end{center}
\end{table}   
%\clearpage
%\include{cdfexamples}
%\include{cmsexamples}
\include{kernelexamples}
\section*{\large Acknowledgements}

\noindent
Numerous discussions about object oriented design with Patrick Schemitz,
Kurt Rinnert and Hartmut Stadie have boosted this project forward.
Patrick Schemitz developed the first I/O scheme for PAX.
Dominic Hirschb\"uhl and Thorsten Walter developed the PAX interface 
to the CDF analysis frame, Christopher Jung an ntuple reader.
Many useful comments of people developing their analysis improved the package,
special thanks to Anne-Sylvie Giolo-Nicollerat.

\renewcommand{\baselinestretch}{1.0}
{\Large\normalsize}
\begin{thebibliography}{9}
\pdfbookmark[0]{References}{ref}
\bibitem{beta}
``Physics Analysis Expert (PAX): first applications''\\
M. Erdmann et al., to appear in the Proceedings of the
International Conference on Computing in High Energy
and Nuclear Physics, CHEP03, La Jolla, USA (2003), 
\href{http://xxx.lanl.gov/abs/physics/0306085}
{http://xxx.lanl.gov/abs/physics/0306085}
\bibitem{alfa}
``Physics Analysis Expert''\\
M.\ Erdmann et al., 
``Physics Analysis Expert'',
Proceedings of the 14th Topical Conference
on Hadron Collider Physics, \href{http://hcp2002.physik.uni-karlsruhe.de/}{HCP2002}, Karlsruhe, Germany (2002)
\bibitem{designpatterns} 
E. Gamma et al., ``Design Patterns'', Addison WesleyISBN 0-201-63361-2, 1994
\end{thebibliography}



\end{document}
